#!/bin/sh
# $Id: run_pgd.sh 9528 2006-09-26 12:45:20Z edgaras $

###
# Configuration section
#
PATH="$PATH:."

NAME=pgd
LOG=/tmp/pgd.log
PROGRAM=`which $NAME`

###
# Common routines section
#

echo_()
{
	echo "run_pgd.sh:" "$*"
}

start_pgd()
{
  	echo_ "starting $NAME..."
	$PROGRAM
	sleep 1
	if [ -s "$LOG" ]
	then
		echo_ "$NAME run log ($LOG):"
		echo  "----------------------------------------"
		cat   "$LOG"
		echo  "----------------------------------------"
	fi
}

stop_pgd()
{
	PID=`pidof -s $NAME`
	if [ $PID ]
	then 
  		echo_ "stopping $NAME..."
		kill $PID
		echo_ "$NAME (pid=$PID) was send a signal."
	else
		echo_ "$NAME processs not running!"
		exit 1
	fi
}

###
# Body...
#

if ! test $PROGRAM
then
	echo_ "$NAME application not found!"
	echo_ "Please check your PATH env. variable."
	exit 0
fi 
if ! test -x $PROGRAM
then
	echo_ "$PROGRAM application not runable!"
	exit 0
fi


case "$1" in
  start)
	PID=`pidof -s $NAME`
	if [ $PID ]
	then
		echo_ "$NAME is already running (pid: $PID)"
		exit 1
	fi

	rm $LOG
	start_pgd
	;;
  stop)
  	stop_pgd
	;;
  restart)
	stop_pgd

	sleep 2

	if [ `pidof -s $NAME` ]
	then
		echo_ "$NAME has not stopped!"
		echo_ "restart failed."
		exit 1
	fi

  	rm $LOG
	start_pgd
	;;
  log)
	PID=`pidof -s $NAME`
	if [ $PID ]
	then 
		echo_ "$NAME is running with pid: $PID"
	else
		echo_ "$NAME processs not running!"
	fi
	
  	if [ -s "$LOG" ]
	then 
		echo_ "log ($LOG):"
		echo  "----------------------------------------"
		cat   "$LOG"
		echo  "----------------------------------------"
	else
		echo_ "log file (\"$LOG\") is empty."
	fi
	;;
  *)
	echo "Usage: $0 {start|stop|restart|log}"
	exit 1
esac

exit 0
