/* $Id: Options.h 9177 2006-09-19 00:58:47Z mindaugas $ */

/* Options */

#import <Cocoa/Cocoa.h>


@interface Options : NSObject
{
	int resolution;
	NSString * fingerID;
	int minutiaCount;
	BOOL duplicates;
	BOOL useG;
	int matchAtMost;
	BOOL matchAllDB;
	BOOL showAllResults;
	BOOL prompt;

	int rExtractionTag;
	int rMatchingTag;
	int rMatchingSpeedTag;
	
	int genCount;

	float tMatchingFARValue;
	float tGeneralizationFARValue;
	int tMatchingRotationValue;
	
	IBOutlet NSApplication * app;
	IBOutlet id appController;

	IBOutlet NSPanel *optionsDialog;

	IBOutlet NSComboBox *eMode;
	IBOutlet NSComboBox *mMode;
	IBOutlet NSComboBox *retImageFormat;

	IBOutlet NSButton *cDuplicate;
	IBOutlet NSButton *cMatchAllDB;
	IBOutlet NSButton *cPrompt;
	IBOutlet NSButton *cShowAllResults;
	IBOutlet NSButton *cUseG;
	IBOutlet NSButton *cUseQuality;

	IBOutlet NSTextField *tFingerID;
	IBOutlet NSTextField *tMatchAtMost;
	IBOutlet NSTextField *tMinutiaCount;
	IBOutlet NSTextField *tResolution;
	IBOutlet NSTextField *tGenNumber;
	
	IBOutlet NSTextField *tGeneralizationFAR;
	IBOutlet NSTextField *tGeneralizationRotation;
	IBOutlet NSTextField *tImageQualityFAR;
	IBOutlet NSTextField *tMatchingFAR;
	IBOutlet NSTextField *tMatchingRotation;

}

- (void) init;
- (int) readFromFile;
//- (void) writeToFile;
- (int)  getResolution;
- (NSString *) getFingerID;
- (int) getMinutiaCount;
- (BOOL) getDuplicates;
- (BOOL) getUseG;
- (int) getMatchAtMost;
- (BOOL) getMatchAllDB;
- (BOOL) getShowAllResults;
- (BOOL) getPrompt;
- (int) getGenCount;

- (IBAction)openOptionsDialog:(id)sender;
- (IBAction)pressCancel:(id)sender;
- (IBAction)pressOk:(id)sender;
- (IBAction)pressSetDefaults:(id)sender;

@end
