/* $Id: Options.m 9178 2006-09-19 00:59:59Z mindaugas $ */

#import "Options.h"
#import "AppController.h"

#define dirToDeg(dir) ((int)(((dir) * 180 + ((dir) < 0 ? -64 : 64)) / 128))
#define degToDir(deg) ((char)(((deg) * 128 + ((deg) < 0 ? -90 : 90)) / 180))

#define Round(value) ((int)(value < 0 ? value - 0.5 : value + 0.5))

const double ThFARLogRatio = 12;

double thresholdToFAR(int th)
{
        if (th < 0)
		{
			th = 0;
		}
        return pow(10.0, -th / ThFARLogRatio + 2);
}

int FARToThreshold(double f)
{
        if (f > 100.0)
		{
			f = 100.0;
		}
        else
		if (f <= 0.0)
		{
			f = 1E-100;
		}
        return Round((-log10(f) + 2) * ThFARLogRatio);
}

@implementation Options

- (void) init
{
	resolution = 500;
	fingerID = @"image";
	minutiaCount = 10;
	duplicates = NO;
	useG = YES;
	matchAtMost = 100;
	matchAllDB = NO;
	showAllResults = NO;
	prompt = YES;
	genCount = 3;
}

- (int) readFromFile;
{
	// FIX ME
}

- (void) writeToFile
{
	// FIX ME
}

- (int)  getResolution
{
	return resolution;
}

- (NSString *) getFingerID
{
	return fingerID;
}

- (int) getMinutiaCount
{
	return minutiaCount;
}

- (BOOL) getDuplicates
{
	return duplicates;
}

- (BOOL) getUseG
{
	return useG;
}

- (int) getMatchAtMost
{
	return matchAtMost;
}

- (BOOL) getMatchAllDB
{
	return matchAllDB;
}

- (BOOL) getShowAllResults
{
	return showAllResults;
}

- (BOOL) getPrompt
{
	return prompt;
}

- (int) getGenCount
{
	return genCount;
}

- (IBAction)openOptionsDialog:(id)sender
{
	int ret;
	int par;
	NByte r_par;
	NBool q_par;
	VfeReturnedImage retImg;
	float FAR;
	
	if (duplicates == YES)
	{
		[cDuplicate setState:NSOnState];
	}
	else
	{
		[cDuplicate setState:NSOffState];
	}

	if (matchAllDB == YES)
	{
		[cMatchAllDB setState:NSOnState];
	}
	else
	{
		[cMatchAllDB setState:NSOffState];
	}
	
	if (prompt == YES)
	{
		[cPrompt setState:NSOnState];
	}
	else
	{
		[cPrompt setState:NSOffState];
	}
	
	if (showAllResults == YES)
	{
		[cShowAllResults setState:NSOnState];
	}
	else
	{
		[cShowAllResults setState:NSOffState];
	}
	
	if (useG == YES)
	{
		[cUseG setState:NSOnState];
	}
	else
	{
		[cUseG setState:NSOffState];
	}

	[tFingerID setStringValue:fingerID];
	[tMatchAtMost setIntValue:matchAtMost];
	[tMinutiaCount setIntValue:minutiaCount];
	[tResolution setIntValue:resolution];
	[tGenNumber setIntValue:genCount];

	ret = VfmGetParameter([appController getHMatcher], VFMP_MODE, (void *)&par);
	if (ret == N_OK)
	{
		switch(par)
		{
		case VFM_MODE_GENERAL:
			[mMode selectItemAtIndex:0];
			break;
		case VFM_MODE_DIGITALPERSONA_UAREU:
			[mMode selectItemAtIndex:1];
			break;
		case VFM_MODE_BIOMETRIKA_FX2000:
			[mMode selectItemAtIndex:2];
			break;
		case VFM_MODE_BIOMETRIKA_FX3000:
			[mMode selectItemAtIndex:3];
			break;
		case VFM_MODE_KEYTRONIC_SECUREDESKTOP:
			[mMode selectItemAtIndex:4];
			break;
		case VFM_MODE_IDENTIX_TOUCHVIEW:
			[mMode selectItemAtIndex:5];
			break;
		case VFM_MODE_IDENTIX_DFR2090:
			[mMode selectItemAtIndex:6];
			break;
		case VFM_MODE_PRECISEBIOMETRICS_100CS:
			[mMode selectItemAtIndex:7];
			break;
		case VFM_MODE_UPEK_TOUCHCHIP:
			[mMode selectItemAtIndex:8];
			break;
		case VFM_MODE_IDENTICATORTECHNOLOGY_DF90:
			[mMode selectItemAtIndex:9];
			break;
		case VFM_MODE_AUTHENTEC_AFS2:
			[mMode selectItemAtIndex:10];
			break;
		case VFM_MODE_AUTHENTEC_AES4000:
			[mMode selectItemAtIndex:11];
			break;
		case VFM_MODE_AUTHENTEC_AES2501B:
			[mMode selectItemAtIndex:12];
			break;
		case VFM_MODE_ATMEL_FINGERCHIP:
			[mMode selectItemAtIndex:13];
			break;
		case VFM_MODE_BMF_BLP100:
			[mMode selectItemAtIndex:14];
			break;
		case VFM_MODE_SECUGEN_HAMSTER:
			[mMode selectItemAtIndex:15];
			break;
		case VFM_MODE_ETHENTICA:
			[mMode selectItemAtIndex:16];
			break;
		case VFM_MODE_CROSSMATCH_VERIFIER300:
			[mMode selectItemAtIndex:17];
			break;
		case VFM_MODE_NITGEN_FINGKEY_HAMSTER:
			[mMode selectItemAtIndex:18];
			break;
		case VFM_MODE_TESTECH_BIOI:
			[mMode selectItemAtIndex:19];
			break;
		case VFM_MODE_DIGENT_IZZIX:
			[mMode selectItemAtIndex:20];
			break;
		case VFM_MODE_STARTEK_FM200:
			[mMode selectItemAtIndex:21];
			break;
		case VFM_MODE_FUJITSU_MBF200:
			[mMode selectItemAtIndex:22];
			break;
		case VFM_MODE_FUTRONIC_FS80:
			[mMode selectItemAtIndex:23];
			break;
		case VFM_MODE_LIGHTUNING_LTTC500:
			[mMode selectItemAtIndex:24];
			break;
		case VFM_MODE_TACOMA_CMOS:
			[mMode selectItemAtIndex:25];
			break;
		}
	}

	ret = VfeGetParameter([appController getHExtractor], VFEP_MODE, (void *)&par);
	if (ret == N_OK)
	{
		switch(par)
		{
		case VFE_MODE_GENERAL:
			[eMode selectItemAtIndex:0];
			break;
		case VFE_MODE_DIGITALPERSONA_UAREU:
			[eMode selectItemAtIndex:1];
			break;
		case VFE_MODE_BIOMETRIKA_FX2000:
			[eMode selectItemAtIndex:2];
			break;
		case VFE_MODE_BIOMETRIKA_FX3000:
			[eMode selectItemAtIndex:3];
			break;
		case VFE_MODE_KEYTRONIC_SECUREDESKTOP:
			[eMode selectItemAtIndex:4];
			break;
		case VFE_MODE_IDENTIX_TOUCHVIEW:
			[eMode selectItemAtIndex:5];
			break;
		case VFE_MODE_IDENTIX_DFR2090:
			[eMode selectItemAtIndex:6];
			break;
		case VFE_MODE_PRECISEBIOMETRICS_100CS:
			[eMode selectItemAtIndex:7];
			break;
		case VFE_MODE_UPEK_TOUCHCHIP:
			[eMode selectItemAtIndex:8];
			break;
		case VFE_MODE_IDENTICATORTECHNOLOGY_DF90:
			[eMode selectItemAtIndex:9];
			break;
		case VFE_MODE_AUTHENTEC_AFS2:
			[eMode selectItemAtIndex:10];
			break;
		case VFE_MODE_AUTHENTEC_AES4000:
			[eMode selectItemAtIndex:11];
			break;
		case VFE_MODE_AUTHENTEC_AES2501B:
			[eMode selectItemAtIndex:12];
			break;
		case VFE_MODE_ATMEL_FINGERCHIP:
			[eMode selectItemAtIndex:13];
			break;
		case VFE_MODE_BMF_BLP100:
			[eMode selectItemAtIndex:14];
			break;
		case VFE_MODE_SECUGEN_HAMSTER:
			[eMode selectItemAtIndex:15];
			break;
		case VFE_MODE_ETHENTICA:
			[eMode selectItemAtIndex:16];
			break;
		case VFE_MODE_CROSSMATCH_VERIFIER300:
			[eMode selectItemAtIndex:17];
			break;
		case VFE_MODE_NITGEN_FINGKEY_HAMSTER:
			[eMode selectItemAtIndex:18];
			break;
		case VFE_MODE_TESTECH_BIOI:
			[eMode selectItemAtIndex:19];
			break;
		case VFE_MODE_DIGENT_IZZIX:
			[eMode selectItemAtIndex:20];
			break;
		case VFE_MODE_STARTEK_FM200:
			[eMode selectItemAtIndex:21];
			break;
		case VFE_MODE_FUJITSU_MBF200:
			[eMode selectItemAtIndex:22];
			break;
		case VFE_MODE_FUTRONIC_FS80:
			[eMode selectItemAtIndex:23];
			break;
		case VFE_MODE_LIGHTUNING_LTTC500:
			[eMode selectItemAtIndex:24];
			break;
		case VFE_MODE_TACOMA_CMOS:
			[eMode selectItemAtIndex:25];
			break;
		}
	}
	
	ret = VfeGetParameter([appController getHExtractor], VFEP_RETURNED_IMAGE, (void *)&retImg);
	if (ret == N_OK)
	{
		switch(retImg)
		{
		case vferiNone:
			[retImageFormat selectItemAtIndex:0];
			break;
		case vferiBinarized:
			[retImageFormat selectItemAtIndex:1];
			break;
		case vferiSkeletonized:
			[retImageFormat selectItemAtIndex:2];
			break;
		}
	}
	
	ret = VfeGetParameter([appController getHExtractor], VFEP_GENERALIZATION_THRESHOLD, &par);
	if (ret == N_OK)
	{
		FAR = thresholdToFAR(par);
		[tGeneralizationFAR setFloatValue:FAR];
	}

	ret = VfeGetParameter([appController getHExtractor], VFEP_GENERALIZATION_MAXIMAL_ROTATION, &r_par);
	if (ret == N_OK)
	{
		ret = dirToDeg(r_par);
		[tGeneralizationRotation setIntValue:ret];
	}
	
	ret = VfeGetParameter([appController getHExtractor], VFEP_USE_QUALITY, &q_par);
	if (ret == N_OK)
	{
		if (q_par == NTrue)
		{
			[cUseQuality setState:NSOnState];
		}
		if (q_par == NFalse)
		{
			[cUseQuality setState:NSOffState];
		}
	}
	
	ret = VfeGetParameter([appController getHExtractor], VFEP_QUALITY_THRESHOLD, &r_par);
	if (ret == N_OK)
	{
		r_par = r_par * 100 / 255;
		[tImageQualityFAR setIntValue:r_par];
	}
	
	ret = VfmGetParameter([appController getHMatcher], VFMP_MATCHING_THRESHOLD, &par);
	if (ret == N_OK)
	{
		FAR = thresholdToFAR(par);
		[tMatchingFAR setFloatValue:FAR];
	}

	ret = VfmGetParameter([appController getHMatcher], VFMP_MAXIMAL_ROTATION, &r_par);
	if (ret == N_OK)
	{
		ret = dirToDeg(r_par);
		[tMatchingRotation setIntValue:ret];
	}

	[app runModalForWindow:optionsDialog];
}

- (IBAction)pressCancel:(id)sender
{
	[app stopModal];
	[optionsDialog close];
}

- (IBAction)pressOk:(id)sender
{
	float FAR;
	int rotation;
	NBool q_par;
	NByte r_par;
	int ret;
	unsigned int spar;
	VfeReturnedImage retImg;

	switch([cDuplicate state])
	{
	case NSOnState:
		duplicates = YES;
		break;
	case NSOffState:
		duplicates = NO;
		break;
	}

	switch([cMatchAllDB state])
	{
	case NSOnState:
		matchAllDB = YES;
		break;
	case NSOffState:
		matchAllDB = NO;
		break;
	}

	switch([cPrompt state])
	{
	case NSOnState:
		prompt = YES;
		break;
	case NSOffState:
		prompt = NO;
		break;
	}
	
	switch([cShowAllResults state])
	{
	case NSOnState:
		showAllResults = YES;
		break;
	case NSOffState:
		showAllResults = NO;
		break;
	}
	
	switch([cUseG state])
	{
	case NSOnState:
		useG = YES;
		break;
	case NSOffState:
		useG = NO;
		break;
	}

	fingerID = [tFingerID stringValue];
	matchAtMost = [tMatchAtMost intValue];
	minutiaCount = [tMinutiaCount intValue];
	resolution = [tResolution intValue];
	genCount = [tGenNumber intValue];
	if (genCount < 3)
	{
		genCount = 3;
	}
	if (genCount > 10)
	{
		genCount = 10;
	}

	switch([eMode indexOfSelectedItem])
	{
	case 0:
		spar = VFE_MODE_GENERAL;
		VfeSetParameter([appController getHExtractor], VFEP_MODE, &spar);
		break;
	case 1:
		spar = VFE_MODE_DIGITALPERSONA_UAREU;
		VfeSetParameter([appController getHExtractor], VFEP_MODE, &spar);
		break;
	case 2:
		spar = VFE_MODE_BIOMETRIKA_FX2000;
		VfeSetParameter([appController getHExtractor], VFEP_MODE, &spar);
		break;
	case 3:
		spar = VFE_MODE_BIOMETRIKA_FX3000;
		VfeSetParameter([appController getHExtractor], VFEP_MODE, &spar);
		break;
	case 4:
		spar = VFE_MODE_KEYTRONIC_SECUREDESKTOP;
		VfeSetParameter([appController getHExtractor], VFEP_MODE, &spar);
		break;
	case 5:
		spar = VFE_MODE_IDENTIX_TOUCHVIEW;
		VfeSetParameter([appController getHExtractor], VFEP_MODE, &spar);
		break;
	case 6:
		spar = VFE_MODE_IDENTIX_DFR2090;
		VfeSetParameter([appController getHExtractor], VFEP_MODE, &spar);
		break;
	case 7:
		spar = VFE_MODE_PRECISEBIOMETRICS_100CS;
		VfeSetParameter([appController getHExtractor], VFEP_MODE, &spar);
		break;
	case 8:
		spar = VFE_MODE_UPEK_TOUCHCHIP;
		VfeSetParameter([appController getHExtractor], VFEP_MODE, &spar);
		break;
	case 9:
		spar = VFE_MODE_IDENTICATORTECHNOLOGY_DF90;
		VfeSetParameter([appController getHExtractor], VFEP_MODE, &spar);
		break;
	case 10:
		spar = VFE_MODE_AUTHENTEC_AFS2;
		VfeSetParameter([appController getHExtractor], VFEP_MODE, &spar);
		break;
	case 11:
		spar = VFE_MODE_AUTHENTEC_AES4000;
		VfeSetParameter([appController getHExtractor], VFEP_MODE, &spar);
		break;
	case 12:
		spar = VFE_MODE_AUTHENTEC_AES2501B;
		VfeSetParameter([appController getHExtractor], VFEP_MODE, &spar);
		break;
	case 13:
		spar = VFE_MODE_ATMEL_FINGERCHIP;
		VfeSetParameter([appController getHExtractor], VFEP_MODE, &spar);
		break;
	case 14:
		spar = VFE_MODE_BMF_BLP100;
		VfeSetParameter([appController getHExtractor], VFEP_MODE, &spar);
		break;
	case 15:
		spar = VFE_MODE_SECUGEN_HAMSTER;
		VfeSetParameter([appController getHExtractor], VFEP_MODE, &spar);
		break;
	case 16:
		spar = VFE_MODE_ETHENTICA;
		VfeSetParameter([appController getHExtractor], VFEP_MODE, &spar);
		break;
	case 17:
		spar = VFE_MODE_CROSSMATCH_VERIFIER300;
		VfeSetParameter([appController getHExtractor], VFEP_MODE, &spar);
		break;
	case 18:
		spar = VFE_MODE_NITGEN_FINGKEY_HAMSTER;
		VfeSetParameter([appController getHExtractor], VFEP_MODE, &spar);
		break;
	case 19:
		spar = VFE_MODE_TESTECH_BIOI;
		VfeSetParameter([appController getHExtractor], VFEP_MODE, &spar);
		break;
	case 20:
		spar = VFE_MODE_DIGENT_IZZIX;
		VfeSetParameter([appController getHExtractor], VFEP_MODE, &spar);
		break;
	case 21:
		spar = VFE_MODE_STARTEK_FM200;
		VfeSetParameter([appController getHExtractor], VFEP_MODE, &spar);
		break;
	case 22:
		spar = VFE_MODE_FUJITSU_MBF200;
		VfeSetParameter([appController getHExtractor], VFEP_MODE, &spar);
		break;
	case 23:
		spar = VFE_MODE_FUTRONIC_FS80;
		VfeSetParameter([appController getHExtractor], VFEP_MODE, &spar);
		break;
	case 24:
		spar = VFE_MODE_LIGHTUNING_LTTC500;
		VfeSetParameter([appController getHExtractor], VFEP_MODE, &spar);
		break;
	case 25:
		spar = VFE_MODE_TACOMA_CMOS;
		VfeSetParameter([appController getHExtractor], VFEP_MODE, &spar);
		break;
	}

	switch([mMode indexOfSelectedItem])
	{
	case 0:
		spar = VFM_MODE_GENERAL;
		VfmSetParameter([appController getHMatcher], VFMP_MODE, &spar);
		break;
	case 1:
		spar = VFM_MODE_DIGITALPERSONA_UAREU;
		VfmSetParameter([appController getHMatcher], VFMP_MODE, &spar);
		break;
	case 2:
		spar = VFM_MODE_BIOMETRIKA_FX2000;
		VfmSetParameter([appController getHMatcher], VFMP_MODE, &spar);
		break;
	case 3:
		spar = VFM_MODE_BIOMETRIKA_FX3000;
		VfmSetParameter([appController getHMatcher], VFMP_MODE, &spar);
		break;
	case 4:
		spar = VFM_MODE_KEYTRONIC_SECUREDESKTOP;
		VfmSetParameter([appController getHMatcher], VFMP_MODE, &spar);
		break;
	case 5:
		spar = VFM_MODE_IDENTIX_TOUCHVIEW;
		VfmSetParameter([appController getHMatcher], VFMP_MODE, &spar);
		break;
	case 6:
		spar = VFM_MODE_IDENTIX_DFR2090;
		VfmSetParameter([appController getHMatcher], VFMP_MODE, &spar);
		break;
	case 7:
		spar = VFM_MODE_PRECISEBIOMETRICS_100CS;
		VfmSetParameter([appController getHMatcher], VFMP_MODE, &spar);
		break;
	case 8:
		spar = VFM_MODE_UPEK_TOUCHCHIP;
		VfmSetParameter([appController getHMatcher], VFMP_MODE, &spar);
		break;
	case 9:
		spar = VFM_MODE_IDENTICATORTECHNOLOGY_DF90;
		VfmSetParameter([appController getHMatcher], VFMP_MODE, &spar);
		break;
	case 10:
		spar = VFM_MODE_AUTHENTEC_AFS2;
		VfmSetParameter([appController getHMatcher], VFMP_MODE, &spar);
		break;
	case 11:
		spar = VFM_MODE_AUTHENTEC_AES4000;
		VfmSetParameter([appController getHMatcher], VFMP_MODE, &spar);
		break;
	case 12:
		spar = VFM_MODE_AUTHENTEC_AES2501B;
		VfmSetParameter([appController getHMatcher], VFMP_MODE, &spar);
		break;
	case 13:
		spar = VFM_MODE_ATMEL_FINGERCHIP;
		VfmSetParameter([appController getHMatcher], VFMP_MODE, &spar);
		break;
	case 14:
		spar = VFM_MODE_BMF_BLP100;
		VfmSetParameter([appController getHMatcher], VFMP_MODE, &spar);
		break;
	case 15:
		spar = VFM_MODE_SECUGEN_HAMSTER;
		VfmSetParameter([appController getHMatcher], VFMP_MODE, &spar);
		break;
	case 16:
		spar = VFM_MODE_ETHENTICA;
		VfmSetParameter([appController getHMatcher], VFMP_MODE, &spar);
		break;
	case 17:
		spar = VFM_MODE_CROSSMATCH_VERIFIER300;
		VfmSetParameter([appController getHMatcher], VFMP_MODE, &spar);
		break;
	case 18:
		spar = VFM_MODE_NITGEN_FINGKEY_HAMSTER;
		VfmSetParameter([appController getHMatcher], VFMP_MODE, &spar);
		break;
	case 19:
		spar = VFM_MODE_TESTECH_BIOI;
		VfmSetParameter([appController getHMatcher], VFMP_MODE, &spar);
		break;
	case 20:
		spar = VFM_MODE_DIGENT_IZZIX;
		VfmSetParameter([appController getHMatcher], VFMP_MODE, &spar);
		break;
	case 21:
		spar = VFM_MODE_STARTEK_FM200;
		VfmSetParameter([appController getHMatcher], VFMP_MODE, &spar);
		break;
	case 22:
		spar = VFM_MODE_FUJITSU_MBF200;
		VfmSetParameter([appController getHMatcher], VFMP_MODE, &spar);
		break;
	case 23:
		spar = VFM_MODE_FUTRONIC_FS80;
		VfmSetParameter([appController getHMatcher], VFMP_MODE, &spar);
		break;
	case 24:
		spar = VFM_MODE_LIGHTUNING_LTTC500;
		VfmSetParameter([appController getHMatcher], VFMP_MODE, &spar);
		break;
	case 25:
		spar = VFM_MODE_TACOMA_CMOS;
		VfmSetParameter([appController getHMatcher], VFMP_MODE, &spar);
		break;
	}
	
	switch([retImageFormat indexOfSelectedItem])
	{
	case 0:
		retImg = vferiNone;
		VfeSetParameter([appController getHExtractor], VFEP_RETURNED_IMAGE, &retImg);
		break;
	case 1:
		retImg = vferiBinarized;
		VfeSetParameter([appController getHExtractor], VFEP_RETURNED_IMAGE, &retImg);
		break;
	case 2:
		retImg = vferiSkeletonized;
		VfeSetParameter([appController getHExtractor], VFEP_RETURNED_IMAGE, &retImg);
		break;
	}
	
	FAR = [tGeneralizationFAR floatValue];
	if (FAR > 0.0)
	{
		ret = FARToThreshold(FAR);
		VfeSetParameter([appController getHExtractor], VFEP_GENERALIZATION_THRESHOLD, &ret);
	}

	rotation = [tGeneralizationRotation intValue];
	if (rotation > 0)
	{
		r_par = degToDir(rotation);
		VfeSetParameter ([appController getHExtractor], VFEP_GENERALIZATION_MAXIMAL_ROTATION, &r_par);
	}
	
	FAR = [tMatchingFAR floatValue];
	if (FAR > 0.0)
	{
		ret = FARToThreshold(FAR);
		VfmSetParameter ([appController getHMatcher], VFMP_MATCHING_THRESHOLD, &ret);
	}
	
	switch([cUseQuality state])
	{
	case NSOnState:
		q_par = NTrue;
		VfeSetParameter([appController getHExtractor], VFEP_USE_QUALITY, &q_par);
		break;
	case NSOffState:
		q_par = NFalse;
		VfeSetParameter([appController getHExtractor], VFEP_USE_QUALITY, &q_par);
		break;
	}
	
	r_par = [tImageQualityFAR intValue];
	if (FAR > 0.0)
	{
		r_par = r_par * 255 / 100;
		VfeSetParameter ([appController getHExtractor], VFEP_QUALITY_THRESHOLD, &r_par);
	}
	
	rotation = [tMatchingRotation intValue];
	if (rotation > 0)
	{
		r_par = degToDir(rotation);
		VfmSetParameter ([appController getHMatcher], VFMP_MAXIMAL_ROTATION, &r_par);
	}

	[app stopModal];
	[optionsDialog close];
}

- (IBAction)pressSetDefaults:(id)sender
{
	[cDuplicate setState:NSOffState];
	[cMatchAllDB setState:NSOffState];
	[cPrompt setState:NSOnState];
	[cShowAllResults setState:NSOffState];
	[cUseG setState:NSOnState];

	[tFingerID setStringValue:@"image"];
	[tMatchAtMost setIntValue:100];
	[tMinutiaCount setIntValue:10];
	[tResolution setIntValue:500];
	
	[tGenNumber setIntValue:3];
	[cUseQuality setState:NSOnState];
	[tImageQualityFAR setIntValue:39];

	[eMode selectItemAtIndex:0];
	[mMode selectItemAtIndex:0];
	[retImageFormat selectItemAtIndex:1];

	[tGeneralizationFAR setFloatValue:0.001];
	[tGeneralizationRotation setIntValue:180];

	[tMatchingFAR setFloatValue:0.01];
	[tMatchingRotation setIntValue:180];
}

@end