#include "StdAfx.h"
#include <VFinger.h>
#include "vfdutils.h"

CString VFErrorToString(INT error)
{
	if (error >= 0) return "";
	CString s;
	CHAR* buffer;
	switch (error)
	{
		case VFE_FAILED: return CString("Failed");
		case VFE_OUT_OF_MEMORY: return CString("Out of memory");
		case VFE_NOT_INITIALIZED: return CString("Not initialized");
		case VFE_ARGUMENT_NULL: return CString("Argument null");
		case VFE_INVALID_ARGUMENT: return CString("Invalid argument");
		case VFE_NOT_IMPLEMENTED: return CString("Not implemented");
		case VFE_NOT_REGISTERED: return CString("Not registered");
		case VFE_INVALID_SERIAL_NUMBER: return CString("Invalid serial number");
		case VFE_INVALID_REGISTRATION_KEY: return CString("Invalid registration key");
		case VFE_SCANNER_DRIVER_ERROR: return CString("Scanner driver error");
		case VFE_REGISTRATION_NOT_NEEDED: return CString("Registration not needed");
		case VFE_NO_SCANNER: return CString("No scanner connected");
		case VFE_MORE_THAN_ONE_SCANNER: return CString("More than one scanner connected");
		case VFE_LM_CONNECTION_ERROR: return CString("Communication with License Manager error");
		case VFE_LM_NO_MORE_LICENSES: return CString("License Manager error: no more licenses");
		case VFE_INVALID_PARAMETER: return CString("Invalid parameter");
		case VFE_PARAMETER_READ_ONLY: return CString("Parameter is read only");
		case VFE_ILLEGAL_IMAGE_RESOLUTION: return CString("Illegal image resolution");
		case VFE_ILLEGAL_IMAGE_SIZE: return CString("Illegal image size");
		case VFE_LOW_QUALITY_IMAGE: return CString("Low quality image");
		case VFE_INVALID_MODE: return CString("Invalid mode");
		case VFE_INVALID_FEATURES_FORMAT: return CString("Invalid features format");
		default: buffer  = new CHAR[]; s = CString(itoa(error,buffer,10)); delete buffer; return s;
	}
}

CString VFResultToString(INT result)
{
	CString log;
	log.Format("OK (%d)", result);
	if (VFFailed(result)) return VFErrorToString(result);
    else return result == VFE_OK ? CString("OK") : log;
}

void VFRaiseError(INT error)
{
	CString s;
	s.Format(" error:\n\tCode = %d\n\tDescription = %s",error,VFErrorToString(error));
	AfxMessageBox(s);
	AfxThrowUserException();
}

void VFCheckResult(INT result)
{
	if (VFFailed(result)) VFRaiseError(result);
}
