Attribute VB_Name = "Service"
Option Explicit

Private Type PicBmp
    Size As Long
    Type As Long
    hBmp As Long
    hPal As Long
    Reserved As Long
End Type

Private Type GUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(7) As Byte
End Type

Public Const IMAGE_BITMAP = 0

Public Const LR_DEFAULTCOLOR = 0
Public Const LR_MONOCHROME = 1
Public Const LR_COLOR = 2
Public Const LR_COPYRETURNORG = &H4
Public Const LR_COPYDELETEORG = &H8
Public Const LR_LOADFROMFILE = &H10
Public Const LR_LOADTRANSPARENT = &H20
Public Const LR_DEFAULTSIZE = &H40
Public Const LR_VGACOLOR = &H80
Public Const LR_LOADMAP3DCOLORS = &H1000
Public Const LR_CREATEDIBSECTION = &H2000
Public Const LR_COPYFROMRESOURCE = &H4000
Public Const LR_SHARED = &H8000

Public Declare Function LoadImage Lib "user32" Alias "LoadImageA" (ByVal hInst As Long, ByVal lpsz As String, ByVal un1 As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal un2 As Long) As Long
Public Declare Function GetLastError Lib "kernel32" () As Long

Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByRef destination As Any, ByRef source As Any, ByVal Length As Long)
Private Declare Function OleCreatePictureIndirect Lib "olepro32.dll" (PicDesc As PicBmp, RefIID As GUID, ByVal fPictureOwnsHandle As Long, IPic As IPicture) As Long

Public Function PictureFromHandle(ByVal hBmp As Long) As IPictureDisp
    Dim r As Long
    Dim pic As PicBmp
    ' IPicture requires a reference to "Standard OLE Types"
    Dim IPic As IPictureDisp
    Dim IID_IDispatch As GUID
    ' Fill in with IDispatch Interface ID
    With IID_IDispatch
        .Data1 = &H7BF80980
        .Data2 = &HBF32
        .Data3 = &H101A
        .Data4(0) = &H8B
        .Data4(1) = &HBB
        .Data4(2) = &H0
        .Data4(3) = &HAA
        .Data4(4) = &H0
        .Data4(5) = &H30
        .Data4(6) = &HC
        .Data4(7) = &HAB
    End With
    ' Fill Pic with necessary parts
    With pic
        .Size = Len(pic)          ' Length of structure
        .Type = vbPicTypeBitmap   ' Type of Picture (bitmap)
        .hBmp = hBmp              ' Handle to bitmap
    End With
    ' Create Picture object
    r = OleCreatePictureIndirect(pic, IID_IDispatch, 1, IPic)
    ' Return the new Picture object
    Set PictureFromHandle = IPic
End Function

Public Function DrawFeatures(w As Long, h As Long, pic As PictureBox, fpd As VFFEATURES, Ratio As Single)
    Dim X As Integer
    Dim Y As Integer
    
    ' blocked orientations
    Dim i As Long
    Dim j As Long
    Dim bs As Long
    Dim hbs As Long
    Dim yy As Long
    Dim xx As Long
    
    If ShowBlockedOrientations Then
        pic.DrawWidth = 1
        
        bs = VF_BLOCK_SIZE
        hbs = bs / 2
        
        yy = hbs
        
        For i = 0 To fpd.bo.height - 1
            xx = hbs
            For j = 0 To fpd.bo.width - 1
                Dim dir As Byte
                
                Dim a As Double
                Dim dx As Long
                Dim dy As Long
                
                dir = fpd.bo.bits(j, i)
                If dir <> VFDIR_BACKGROUND Then
                     If dir <> VFDIR_UNKNOWN Then
                        
                        a = VFDirToRad(dir)
                       
                        dx = Round(Cos(a) * hbs)
                        dy = Round(Sin(a) * hbs)
                        
                        pic.Line (xx, yy)-(xx + dx, (yy + dy)), rgb(0, 0, 255)
                        pic.Line (xx, yy)-(xx - dx, (yy - dy)), rgb(0, 0, 255)
    
                     Else
                     
                        a = VFDirToRad(VFDIR_0)
                        
                        dx = Round(Cos(a) * hbs)
                        dy = Round(Sin(a) * hbs)
                        
                        pic.Line (xx, yy)-(xx + dx, (yy + dy)), rgb(0, 0, 255)
                        pic.Line (xx, yy)-(xx - dx, (yy - dy)), rgb(0, 0, 255)
                        
                        a = VFDirToRad(VFDIR_45)
                        
                        dx = Round(Cos(a) * hbs)
                        dy = Round(Sin(a) * hbs)
                        
                        pic.Line (xx, yy)-(xx + dx, (yy + dy)), rgb(0, 0, 255)
                        pic.Line (xx, yy)-(xx - dx, (yy - dy)), rgb(0, 0, 255)
                        
                        a = VFDirToRad(VFDIR_90)
                        
                        dx = Round(Cos(a) * hbs)
                        dy = Round(Sin(a) * hbs)
                        
                        pic.Line (xx, yy)-(xx + dx, (yy + dy)), rgb(0, 0, 255)
                        pic.Line (xx, yy)-(xx - dx, (yy - dy)), rgb(0, 0, 255)
                        
                        a = VFDirToRad(VFDIR_135)
                        
                        dx = Round(Cos(a) * hbs)
                        dy = Round(Sin(a) * hbs)
                        
                        pic.Line (xx, yy)-(xx + dx, (yy + dy)), rgb(0, 0, 255)
                        pic.Line (xx, yy)-(xx - dx, (yy - dy)), rgb(0, 0, 255)
                    End If
                End If
                
                xx = xx + bs
            Next j
            yy = yy + bs
        Next i
    End If

    ' minuties
    If ShowMinutiaes Then
        pic.DrawWidth = 2
        'Dim i As Long
        For i = 0 To fpd.m.count - 1
            X = 10 * Cos(3.14 / VFDIR_180 * fpd.m.D(i))
            Y = 10 * Sin(3.14 / VFDIR_180 * fpd.m.D(i))
            pic.Line (Ratio * fpd.m.X(i), Ratio * fpd.m.Y(i))-(Ratio * fpd.m.X(i) + X, (Ratio * fpd.m.Y(i) + Y)), rgb(255, 0, 0)
            pic.Circle (Ratio * fpd.m.X(i), Ratio * fpd.m.Y(i)), 4, rgb(255, 0, 0)
        Next i
    End If
    
    ' singular points
    If ShowSingularPoints Then
        pic.DrawWidth = 4
        For i = 0 To fpd.sp.count - 1
            Select Case fpd.sp.t(i)
            Case VFFEAT_SP_DOUBLECORE:
                pic.Circle (Ratio * fpd.sp.X(i), Ratio * fpd.sp.Y(i)), 8, rgb(255, 0, 0)
            Case VFFEAT_SP_CORE:
                X = fpd.sp.X(i) - 8
                Y = fpd.sp.Y(i) - 8
                pic.Line (Ratio * X, Ratio * Y)-(Ratio * (X + 16 - 1), Ratio * Y), rgb(255, 0, 0)
                pic.Line -(Ratio * (X + 16 - 1), Ratio * (Y + 16 - 1)), rgb(255, 0, 0)
                pic.Line -(Ratio * X, Ratio * (Y + 16 - 1)), rgb(255, 0, 0)
                pic.Line -(Ratio * X, Ratio * Y), rgb(255, 0, 0)
                X = 16 * Cos(3.14 / VFDIR_180 * fpd.sp.D(i))
                Y = 16 * Sin(3.14 / VFDIR_180 * fpd.sp.D(i))
                pic.Line (Ratio * fpd.sp.X(i), Ratio * fpd.sp.Y(i))-(Ratio * (fpd.sp.X(i) + X), (Ratio * (fpd.sp.Y(i) + Y))), rgb(255, 0, 0)
            Case VFFEAT_SP_DELTA:
                X = fpd.sp.X(i) - 8
                Y = fpd.sp.Y(i) + 8
                pic.Line (Ratio * X, Ratio * Y)-(Ratio * (X + 16 / 2), Ratio * (Y - 16 - 1)), rgb(255, 0, 0)
                pic.Line -(Ratio * (X + 16 - 1), Ratio * Y), rgb(255, 0, 0)
                pic.Line -(Ratio * X, Ratio * Y), rgb(255, 0, 0)
            End Select
        Next i
    End If
End Function

Public Sub ByteArrayCopy(target() As Byte, source As Variant, Size As Long)
    ReDim target(Size)
    CopyMemory target(0), source(0), Size
End Sub

