#include "System.h"
#include "OptionsForm.h"
#include "VFingerX.h"
#include "FileListEntryForm.h"
#include "VFDatabase.h"

//////////////////
//              //
// COptionsForm //
//              //
//////////////////

COptionsForm::COptionsForm()
{
	SetMinimizeBox(false);
	SetMaximizeBox(false);
	SetFormBorder(fbDialog);
	SetFormPosition(fpOwnerCenter);
	SetText(STRING("Options"));

	int x = 8, y = 8;

	checkBoxUseLowQualityImages = new CCheckBox();
	checkBoxUseLowQualityImages->SetText(STRING("Use low &quality images"));
	checkBoxUseLowQualityImages->SetLeft(x);
	checkBoxUseLowQualityImages->SetTop(y);
	checkBoxUseLowQualityImages->SetWidth(130);
	y += checkBoxUseLowQualityImages->Height() + 8;

	int xx, yy, ww;

	CGroupBox * groupBoxFile = new CGroupBox();
	groupBoxFile->SetText(STRING("Images from file"));
	groupBoxFile->SetLeft(x);
	groupBoxFile->SetTop(y);
	yy = groupBoxFile->Top() + 16;
	xx = groupBoxFile->Left() + 8;
	ww = 60;
	CLabel * labelFileResolutionPrefix = new CLabel();
	labelFileResolutionPrefix->SetText(STRING("Resolution:"));
	labelFileResolutionPrefix->SetGroup(true);
	labelFileResolutionPrefix->SetLeft(xx);
	labelFileResolutionPrefix->SetWidth(ww);
	labelFileResolution = new CLabel();
	labelFileResolution->SetLeft(labelFileResolutionPrefix->Right() + 4);
	labelFileResolution->SetTop(yy);
	labelFileResolution->SetWidth(30);
	labelFileResolutionPrefix->SetVCenter(labelFileResolution->VCenter());
	CLabel * labelFileResolutionSuffix = new CLabel();
	labelFileResolutionSuffix->SetText(STRING("dpi"));
	labelFileResolutionSuffix->SetLeft(labelFileResolution->Right() + 4);
	labelFileResolutionSuffix->SetVCenter(labelFileResolution->VCenter());
	yy += labelFileResolution->Height() + 4;
	CLabel * labelFileFingerIdTitle = new CLabel();
	labelFileFingerIdTitle->SetText(STRING("Finger ID:"));
	labelFileFingerIdTitle->SetLeft(xx);
	labelFileFingerIdTitle->SetWidth(ww);
	labelFileFingerId = new CLabel();
	labelFileFingerId->SetLeft(labelFileFingerIdTitle->Right() + 4);
	labelFileFingerId->SetTop(yy);
	labelFileFingerId->SetWidth(150);
	labelFileFingerIdTitle->SetVCenter(labelFileFingerId->VCenter());
	yy += labelFileFingerId->Height() + 4;
	buttonFileEdit = new CButton();
	buttonFileEdit->SetText(STRING("&Edit..."));
	buttonFileEdit->SetRight(labelFileFingerId->Right());
	buttonFileEdit->SetTop(yy);
	yy += buttonFileEdit->Height() + 8;
	checkBoxFilePrompt = new CCheckBox();
	checkBoxFilePrompt->SetText(STRING("Prompt for &info"));
	checkBoxFilePrompt->SetLeft(xx);
	checkBoxFilePrompt->SetVCenter(buttonFileEdit->VCenter());
	checkBoxFilePrompt->SetWidth(90);
	xx = labelFileFingerId->Right() + 8;
	groupBoxFile->SetSize(xx - groupBoxFile->Left(), yy - y);

	CGroupBox * groupBoxScanner = new CGroupBox();
	groupBoxScanner->SetText(STRING("Images from scanner"));
	groupBoxScanner->SetLeft(groupBoxFile->Right() + 4);
	groupBoxScanner->SetTop(y);
	yy = groupBoxScanner->Top() + 16;
	xx = groupBoxScanner->Left() + 8;
	ww = 50;
	CLabel * labelScannerFingerIdTitle = new CLabel();
	labelScannerFingerIdTitle->SetText(STRING("Finger ID:"));
	labelScannerFingerIdTitle->SetGroup(true);
	labelScannerFingerIdTitle->SetLeft(xx);
	labelScannerFingerIdTitle->SetWidth(ww);
	labelScannerFingerId = new CLabel();
	labelScannerFingerId->SetLeft(labelScannerFingerIdTitle->Right() + 4);
	labelScannerFingerId->SetTop(yy);
	labelScannerFingerId->SetWidth(160);
	labelScannerFingerIdTitle->SetVCenter(labelScannerFingerId->VCenter());
	yy += labelScannerFingerId->Height() + 4;
	buttonScannerEdit = new CButton();
	buttonScannerEdit->SetText(STRING("Edi&t..."));
	buttonScannerEdit->SetRight(labelScannerFingerId->Right());
	buttonScannerEdit->SetTop(yy);
	yy += buttonScannerEdit->Height() + 8;
	checkBoxScannerPrompt = new CCheckBox();
	checkBoxScannerPrompt->SetText(STRING("Prompt for in&fo"));
	checkBoxScannerPrompt->SetLeft(xx);
	checkBoxScannerPrompt->SetVCenter(buttonScannerEdit->VCenter());
	checkBoxScannerPrompt->SetWidth(90);
	xx = labelScannerFingerId->Right() + 8;
	groupBoxScanner->SetWidth(xx - groupBoxScanner->Left());
	groupBoxScanner->SetHeight(groupBoxFile->Height());

	y += groupBoxFile->Height() + 4;

	CGroupBox * groupBoxEnrollment = new CGroupBox();
	groupBoxEnrollment->SetText(STRING("Enrollment"));
	groupBoxEnrollment->SetLeft(x);
	groupBoxEnrollment->SetTop(y);
	xx = groupBoxEnrollment->Left() + 8;
	yy = groupBoxEnrollment->Top() + 16;
	checkBoxMinimalMinutiaCount = new CCheckBox();
	checkBoxMinimalMinutiaCount->SetText(STRING("Mi&nimal minutia count"));
	checkBoxMinimalMinutiaCount->SetGroup(true);
	checkBoxMinimalMinutiaCount->SetLeft(xx);
	checkBoxMinimalMinutiaCount->SetWidth(126);
	editMinimalMinutiaCount = new CEdit();
	editMinimalMinutiaCount->SetLeft(checkBoxMinimalMinutiaCount->Right() + 4);
	editMinimalMinutiaCount->SetTop(yy);
	editMinimalMinutiaCount->SetWidth(40);
	checkBoxMinimalMinutiaCount->SetVCenter(editMinimalMinutiaCount->VCenter());
	yy += editMinimalMinutiaCount->Height() + 4;
	checkBoxSearchForDuplicates = new CCheckBox();
	checkBoxSearchForDuplicates->SetText(STRING("Search for du&plicates"));
	checkBoxSearchForDuplicates->SetLeft(xx);
	checkBoxSearchForDuplicates->SetTop(yy);
	checkBoxSearchForDuplicates->SetWidth(120);
	yy += checkBoxSearchForDuplicates->Height() + 4;
	checkBoxWarnDifferentFingerId = new CCheckBox();
	checkBoxWarnDifferentFingerId->SetText(STRING("&Warn only if finger ids differs"));
	checkBoxWarnDifferentFingerId->SetLeft(xx + 16);
	checkBoxWarnDifferentFingerId->SetTop(yy);
	checkBoxWarnDifferentFingerId->SetWidth(150);
	yy += checkBoxWarnDifferentFingerId->Height() + 8;
	groupBoxEnrollment->SetWidth(groupBoxFile->Width());

	CGroupBox * groupBoxIdentification = new CGroupBox();
	groupBoxIdentification->SetText(STRING("Identification"));
	groupBoxIdentification->SetLeft(groupBoxEnrollment->Right() + 4);
	groupBoxIdentification->SetTop(y);
	xx = groupBoxIdentification->Left() + 8;
	yy = groupBoxIdentification->Top() + 16;
	checkBoxCheckForEmptyDatabase = new CCheckBox();
	checkBoxCheckForEmptyDatabase->SetLeft(xx);
	checkBoxCheckForEmptyDatabase->SetTop(yy);
	checkBoxCheckForEmptyDatabase->SetText(STRING("Check for empt&y database"));
	checkBoxCheckForEmptyDatabase->SetWidth(160);
	yy += checkBoxCheckForEmptyDatabase->Height() + 4;
	checkBoxUseG = new CCheckBox();
	checkBoxUseG->SetText(STRING("Use &G"));
	checkBoxUseG->SetGroup(true);
	checkBoxUseG->SetLeft(xx);
	checkBoxUseG->SetTop(yy);
	checkBoxUseG->SetWidth(50);
	yy += checkBoxUseG->Height() + 4;
	labelDatabasePercentPrefix = new CLabel();
	labelDatabasePercentPrefix->SetText(STRING("Match at m&ost"));
	labelDatabasePercentPrefix->SetLeft(xx + 16);
	labelDatabasePercentPrefix->SetWidth(70);
	editDatabasePercent = new CEdit();
	editDatabasePercent->SetLeft(labelDatabasePercentPrefix->Right() + 4);
	editDatabasePercent->SetTop(yy);
	editDatabasePercent->SetWidth(30);
	labelDatabasePercentSuffix = new CLabel();
	labelDatabasePercentSuffix->SetText(STRING("% of database"));
	labelDatabasePercentSuffix->SetLeft(editDatabasePercent->Right() + 4);
	labelDatabasePercentPrefix->SetVCenter(editDatabasePercent->VCenter());
	labelDatabasePercentSuffix->SetVCenter(editDatabasePercent->VCenter());
	labelDatabasePercentSuffix->SetWidth(70);
	yy += editDatabasePercent->Height() + 4;
	checkBoxMatchAllDatabase = new CCheckBox();
	checkBoxMatchAllDatabase->SetText(STRING("Match &all database"));
	checkBoxMatchAllDatabase->SetLeft(xx);
	checkBoxMatchAllDatabase->SetTop(yy);
	checkBoxMatchAllDatabase->SetWidth(110);
	yy += checkBoxMatchAllDatabase->Height() + 4;
	checkBoxShowAllResults = new CCheckBox();
	checkBoxShowAllResults->SetText(STRING("Show all &results"));
	checkBoxShowAllResults->SetLeft(xx);
	checkBoxShowAllResults->SetTop(yy);
	checkBoxShowAllResults->SetWidth(90);
	yy += checkBoxShowAllResults->Height() + 8;
	groupBoxIdentification->SetHeight(yy - y);
	groupBoxIdentification->SetWidth(groupBoxScanner->Width());
	groupBoxEnrollment->SetHeight(groupBoxIdentification->Height());

	y += groupBoxEnrollment->Height() + 12;
	x = groupBoxIdentification->Right();

	buttonOK = new CButton();
	buttonOK->SetDefault(true);
	buttonOK->SetModalResult(IDOK);
	buttonOK->SetText(STRING("OK"));
	buttonCancel = new CButton();
	buttonCancel->SetCancel(true);
	buttonCancel->SetModalResult(IDCANCEL);
	buttonCancel->SetText(STRING("Cancel"));
	buttonDefault = new CButton();
	buttonDefault->SetText(STRING("&Default"));
	buttonDefault->SetTop(y);
	buttonDefault->SetRight(x);
	buttonCancel->SetTop(buttonDefault->Top());
	buttonCancel->SetRight(buttonDefault->Left() - 8);
	buttonOK->SetTop(buttonCancel->Top());
	buttonOK->SetRight(buttonCancel->Left() - 8);

	x += 8;
	y += buttonDefault->Height() + 8;
	SetClientSize(x, y);

	AddControl(checkBoxUseLowQualityImages);

	AddControl(labelFileResolutionPrefix);
	AddControl(labelFileResolution);
	AddControl(labelFileResolutionSuffix);
	AddControl(labelFileFingerIdTitle);
	AddControl(labelFileFingerId);
	AddControl(checkBoxFilePrompt);
	AddControl(buttonFileEdit);
	AddControl(groupBoxFile);

	AddControl(labelScannerFingerIdTitle);
	AddControl(labelScannerFingerId);
	AddControl(checkBoxScannerPrompt);
	AddControl(buttonScannerEdit);
	AddControl(groupBoxScanner);

	AddControl(checkBoxMinimalMinutiaCount);
	AddControl(editMinimalMinutiaCount);
	AddControl(checkBoxSearchForDuplicates);
	AddControl(checkBoxWarnDifferentFingerId);
	AddControl(groupBoxEnrollment);

	AddControl(checkBoxCheckForEmptyDatabase);
	AddControl(checkBoxUseG);
	AddControl(labelDatabasePercentPrefix);
	AddControl(editDatabasePercent);
	AddControl(labelDatabasePercentSuffix);
	AddControl(checkBoxMatchAllDatabase);
	AddControl(checkBoxShowAllResults);
	AddControl(groupBoxIdentification);

	AddControl(buttonOK);
	AddControl(buttonCancel);
	AddControl(buttonDefault);

	UpdateMinimalMinutiaCount();
	UpdateSearchForDuplicates();
	UpdateUseG();

	SetActiveControl(checkBoxUseLowQualityImages);
}

void COptionsForm::OnCommand(WORD /*id*/, WORD event, CControl * control)
{
	if(control)
	{
		if(event == BN_CLICKED)
		{
			if(control == buttonDefault)
				SetDefaultOptions();
			else if(control == buttonFileEdit)
				EditInfo(labelFileFingerId, labelFileResolution, false);
			else if(control == buttonScannerEdit)
				EditInfo(labelScannerFingerId, NULL, true);
			else if(control == checkBoxMinimalMinutiaCount)
				UpdateMinimalMinutiaCount();
			else if(control == checkBoxSearchForDuplicates)
				UpdateSearchForDuplicates();
			else if(control == checkBoxUseG)
				UpdateUseG();
		}
	}
}

void COptionsForm::CheckMinimalMinutiaCount()
{
	if(checkBoxMinimalMinutiaCount->Checked())
		try
		{
			int value = MinimalMinutiaCount;
			if(value < 0)
				throw exception("Minimal minutia count have to be not less than zero");
		}
		catch(exception &)
		{
			editMinimalMinutiaCount->SetFocus();
			throw;
		}
}

void COptionsForm::CheckDatabasePercent()
{
	if(checkBoxUseG->Checked())
		try
		{
			int value = DatabasePercent;
			if(value < 0 || value > 100)
				throw exception("Database percent have to be in range from 0 to 100");
		}
		catch(exception &)
		{
			editDatabasePercent->SetFocus();
			throw;
		}
}

bool COptionsForm::OnCloseQuery()
{
	if(ModalResult() == IDOK)
	{
		try
		{
			CheckMinimalMinutiaCount();
			CheckDatabasePercent();
			return true;
		}
		catch(exception &e)
		{
			ErrorBox(this, e);
		}
		return false;
	}
	else return true;
}

void COptionsForm::SetDefaultOptions()
{
	SetOptions(vfDemoDefaultOptions);
}

void COptionsForm::EditInfo(CLabel * labelFingerId, CLabel * labelResolution, bool fromScanner)
{
	DWORD flags = FLEB_NEW_ENTRY | FLEB_MANY_ENTRIES;
	string source;
	int resolution;
	string fingerId = GetFingerId(labelFingerId);
	if(fromScanner)
	{
		source = TEXT("Name\\ID");
		SetFlag(flags, FLEB_FROM_SCANNER);
		resolution = -1;
	}
	else
	{
		source = TEXT("C:\\Dir1\\Dir2\\filename.ext");
		resolution = GetResolution(labelResolution);
	}
	if(FileListEntryBox(this, flags, source, resolution, fingerId))
	{
		SetFingerId(labelFingerId, fingerId);
		if(!fromScanner) SetResolution(labelResolution, resolution);
	}
}

void COptionsForm::UpdateMinimalMinutiaCount()
{
	editMinimalMinutiaCount->SetEnabled(checkBoxMinimalMinutiaCount->Checked());
}

void COptionsForm::UpdateSearchForDuplicates()
{
	checkBoxWarnDifferentFingerId->SetEnabled(checkBoxSearchForDuplicates->Checked());
}

void COptionsForm::UpdateUseG()
{
	bool useDatabasePercent = checkBoxUseG->Checked();
	labelDatabasePercentPrefix->SetEnabled(useDatabasePercent);
	editDatabasePercent->SetEnabled(useDatabasePercent);
	labelDatabasePercentSuffix->SetEnabled(useDatabasePercent);
}

void COptionsForm::GetOptions(VFDemoOptions &value)
{
	value.useLowQualityImages = checkBoxUseLowQualityImages->Checked();

	value.imagesFromFile.resolution = GetResolution(labelFileResolution);
	value.imagesFromFile.fingerId = GetFingerId(labelFileFingerId);
	value.imagesFromFile.prompt = checkBoxFilePrompt->Checked();

	value.imagesFromScanner.fingerId = GetFingerId(labelScannerFingerId);
	value.imagesFromScanner.prompt = checkBoxScannerPrompt->Checked();

	value.enrollment.checkMinimalMinutiaCount = checkBoxMinimalMinutiaCount->Checked();
	if(value.enrollment.checkMinimalMinutiaCount) value.enrollment.minimalMinutiaCount = MinimalMinutiaCount;
	value.enrollment.searchForDuplicates = checkBoxSearchForDuplicates->Checked();
	if(value.enrollment.searchForDuplicates) value.enrollment.warnDifferentFingerId = checkBoxWarnDifferentFingerId->Checked();

	value.identification.checkForEmptyDatabase = checkBoxCheckForEmptyDatabase->Checked();
	value.identification.useG = checkBoxUseG->Checked();
	if(value.identification.useG) value.identification.databasePercent = DatabasePercent;
	value.identification.matchAllDatabase = checkBoxMatchAllDatabase->Checked();
	value.identification.showAllResults = checkBoxShowAllResults->Checked();
}

void COptionsForm::SetOptions(const VFDemoOptions &value)
{
	checkBoxUseLowQualityImages->SetChecked(value.useLowQualityImages);

	SetResolution(labelFileResolution, value.imagesFromFile.resolution);
	SetFingerId(labelFileFingerId, value.imagesFromFile.fingerId);
	checkBoxFilePrompt->SetChecked(value.imagesFromFile.prompt);
	
	SetFingerId(labelScannerFingerId, value.imagesFromScanner.fingerId);
	checkBoxScannerPrompt->SetChecked(value.imagesFromScanner.prompt);

	checkBoxMinimalMinutiaCount->SetChecked(value.enrollment.checkMinimalMinutiaCount);
	UpdateMinimalMinutiaCount();
	MinimalMinutiaCount = value.enrollment.minimalMinutiaCount;
	checkBoxSearchForDuplicates->SetChecked(value.enrollment.searchForDuplicates);
	UpdateSearchForDuplicates();
	checkBoxWarnDifferentFingerId->SetChecked(value.enrollment.warnDifferentFingerId);

	checkBoxCheckForEmptyDatabase->SetChecked(value.identification.checkForEmptyDatabase);
	checkBoxUseG->SetChecked(value.identification.useG);
	UpdateUseG();
	DatabasePercent = value.identification.databasePercent;
	checkBoxMatchAllDatabase->SetChecked(value.identification.matchAllDatabase);
	checkBoxShowAllResults->SetChecked(value.identification.showAllResults);
}

////////////////
//            //
// OptionsBox //
//            //
////////////////

bool OptionsBox(CForm * owner, VFDemoOptions &options)
{
	COptionsForm * form = new COptionsForm();
	form->SetOwner(owner);
	form->SetOptions(options);
	bool ok = form->ShowModal() == IDOK;
	if(ok)
	{
		form->GetOptions(options);
	}
	delete form;
	return ok;
}
