#include "System.h"
#include "VFOptions.h"
#include "Utils.h"
#include "VFingerX.h"

VFOptions vfDefaultOptions;

void VFInitDefaultOptions()
{
	VFSynchronizeOptions(vfDefaultOptions);
}

void VFSynchronizeOptions(VFOptions &options)
{
	options.mode = VFGetIntParameter(VFP_MODE);

	options.returnedImage = VFGetIntParameter(VFP_RETURNED_IMAGE);

	options.matchingThreshold = VFGetIntParameter(VFP_MATCHING_THRESHOLD);
	options.matchingSpeed = VFGetIntParameter(VFP_MATCHING_SPEED);
	options.maximalRotation = VFGetIntParameter(VFP_MAXIMAL_ROTATION);

	options.generalizationThreshold = VFGetIntParameter(VFP_GENERALIZATION_THRESHOLD);
	options.genMaximalRotation = VFGetIntParameter(VFP_GEN_MAXIMAL_ROTATION);
}

#define IGNORE_EXCEPTION(statement) \
	try\
	{\
		statement;\
	}\
	catch(exception &)\
	{\
	}

void VFUpdateOptions(VFOptions &options)
{
	IGNORE_EXCEPTION(VFSetIntParameter(VFP_MODE, options.mode))

	IGNORE_EXCEPTION(VFSetIntParameter(VFP_RETURNED_IMAGE, options.returnedImage))

	IGNORE_EXCEPTION(VFSetIntParameter(VFP_MATCHING_THRESHOLD, options.matchingThreshold))
	IGNORE_EXCEPTION(VFSetIntParameter(VFP_MATCHING_SPEED, options.matchingSpeed))
	IGNORE_EXCEPTION(VFSetIntParameter(VFP_MAXIMAL_ROTATION, options.maximalRotation))

	IGNORE_EXCEPTION(VFSetIntParameter(VFP_GENERALIZATION_THRESHOLD, options.generalizationThreshold))
	IGNORE_EXCEPTION(VFSetIntParameter(VFP_GEN_MAXIMAL_ROTATION, options.genMaximalRotation))

	VFSynchronizeOptions(options);
}

void VFLoadOptions(MSXML2::IXMLDOMNodePtr node, VFOptions &value)
{
	MSXML2::IXMLDOMNamedNodeMapPtr attributes = node->attributes;

	XmlGetAttributeMemberValue(attributes, value, mode, StringToInt);

	XmlGetAttributeMemberValue(attributes, value, returnedImage, StringToInt);

	XmlGetAttributeMemberValue(attributes, value, matchingThreshold, StringToInt);
	XmlGetAttributeMemberValue(attributes, value, matchingSpeed, StringToInt);
	XmlGetAttributeMemberValue(attributes, value, maximalRotation, StringToInt);

	XmlGetAttributeMemberValue(attributes, value, generalizationThreshold, StringToInt);
	XmlGetAttributeMemberValue(attributes, value, genMaximalRotation, StringToInt);
}

void VFSaveOptions(MSXML2::IXMLDOMDocumentPtr document, MSXML2::IXMLDOMNodePtr node, const VFOptions &value)
{
	MSXML2::IXMLDOMNamedNodeMapPtr attributes = node->attributes;

	XmlSetAttributeMemberValue(document, attributes, value, mode, IntToString);

	XmlSetAttributeMemberValue(document, attributes, value, returnedImage, IntToString);

	XmlSetAttributeMemberValue(document, attributes, value, matchingThreshold, IntToString);
	XmlSetAttributeMemberValue(document, attributes, value, matchingSpeed, IntToString);
	XmlSetAttributeMemberValue(document, attributes, value, maximalRotation, IntToString);

	XmlSetAttributeMemberValue(document, attributes, value, generalizationThreshold, IntToString);
	XmlSetAttributeMemberValue(document, attributes, value, genMaximalRotation, IntToString);
}
