package ScanMan;

import java.lang.*;

public class ScanMan {

    // Parameter types
    public static final int SM_TYPE_VOID    = 0;
    public static final int SM_TYPE_BYTE    = 1;
    public static final int SM_TYPE_SBYTE   = 2;
    public static final int SM_TYPE_WORD    = 3;
    public static final int SM_TYPE_SHORT   = 4;
    public static final int SM_TYPE_DWORD   = 5;
    public static final int SM_TYPE_INT     = 6;
    public static final int SM_TYPE_BOOL    = 10;
    public static final int SM_TYPE_CHAR    = 20;
    public static final int SM_TYPE_STRING  = 100;

    // Parameters - general
    public static final int SMP_NAME          = 10; // Get | String
    public static final int SMP_VERSION_HIGH  = 11; // Get | DWord
    public static final int SMP_VERSION_LOW   = 12; // Get | DWord
    public static final int SMP_COPYRIGHT     = 13; // Get | String
    
    // Functions:
    
    // Initialization
    public static native void SMInitialize() throws ScanManException, Exception;
    public static native void SMFinalize() throws ScanManException, Exception;

    // Parameters
    public static native String getParameterValue(int parameter) throws ScanManException, Exception;
    public static native void setParameterValue(int parameter, String value) throws ScanManException, Exception;
    public static native int getParameterType(int parameter) throws ScanManException, Exception;

    // Scanner enumeration
    public static native int SMGetScannerCount() throws ScanManException, Exception;
    public static native String SMGetScannerId(int index) throws ScanManException, Exception;

    // Scanner monitoring
    public static native void SMSetMonitor(ScannersMonitor monitor) throws ScanManException, Exception;
    public static native void SMRemoveMonitor() throws ScanManException, Exception;

    // Capturing
    public static native void SMStartCapturing(String id, ScannerEventListener listener) throws ScanManException, Exception;
    public static native void SMStopCapturing(String id) throws ScanManException, Exception;

    private ScanMan() {		
	}
	
	static
	{		
        try {
	        System.loadLibrary("SMJavaW");
	    }
		catch (UnsatisfiedLinkError e) {
		    System.out.println("Error loading ScanMan - " + e.getMessage());
			e.printStackTrace();
		}
	}
}