package VeriFinger;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;

/**
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class FingerprintData implements Serializable, Comparable {
        private byte[] features;
        private String title;

        public FingerprintData(String title, byte[] features) {
                this.title = title;
                this.features = features;
        }

        public String getTitle() {
                return title;
        }

        public byte[] getFeatures() {
                return features;
        }

        public int getG() {
                return (int) (features[1] & 0xFF);
        }

        private void writeObject(ObjectOutputStream out)
                throws IOException {
                out.writeObject(title);
                out.writeInt(features.length);
                for (int i = 0; i < features.length; ++i)
                        out.writeByte(features[i]);
        }

        private void readObject(ObjectInputStream in)
                throws IOException, ClassNotFoundException {
        title = (String) in.readObject();
        int length = in.readInt();
        features = new byte[VeriFingerWrapper.VF_MAX_FEATURES_SIZE];
            for (int i = 0; i < length; ++i)
                        features[i] = in.readByte();
     }

        public int compareTo(Object o) {
                if (o instanceof FingerprintData) {
                        FingerprintData fd = (FingerprintData) o;
                        return title.compareTo(fd.title);
                }
                return -1;
        }

}
