using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Neurotec.Biometrics.VeriFingerDemo
{
	public partial class IdentificationDetailsForm : Form
	{
		#region Private fields

		private IList<MatchingResult> results;

		#endregion

		#region Public constructor

		public IdentificationDetailsForm()
		{
			InitializeComponent();

			dataGridView.AutoGenerateColumns = false;
			DataGridViewTextBoxColumn idColumn = new DataGridViewTextBoxColumn();
			idColumn.DataPropertyName = "RecordID";
			idColumn.HeaderText = "ID";
			dataGridView.Columns.Add(idColumn);
			DataGridViewTextBoxColumn scoreColumn = new DataGridViewTextBoxColumn();
			scoreColumn.DataPropertyName = "Score";
			scoreColumn.HeaderText = "Score";
			dataGridView.Columns.Add(scoreColumn);

			OnResultsChanged();
		}

		#endregion

		#region Private methods

		private void OnResultsChanged()
		{
			dataGridView.DataSource = results;
		}

		#endregion

		#region Public properties

		public IList<MatchingResult> Results
		{
			get
			{
				return results;
			}
			set
			{
				if (results != value)
				{
					results = value;
					OnResultsChanged();
				}
			}
		}

		#endregion
	}
}
