﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Neurotec.Biometrics.VeriFingerDemo
{
    public static class StringUtils
    {
        public static string GetLeft(string str, int count)
        {
            if(str == null) return null;
            int length = str.Length;
            if(Math.Abs(count) > length) count = Math.Sign(count) * length;
            return count >= 0 ? str.Substring(0, count) : str.Substring(-count);
        }

        public static string GetRight(string str, int count)
        {
            if(str == null) return null;
            int length = str.Length;
            if(Math.Abs(count) > length) count = Math.Sign(count) * length;
            return count >= 0 ? str.Substring(length - count) : str.Substring(0, length + count);
        }

        public static string GetCenter(string str, int index, int count)
        {
            if(str == null) return null;
            int length = str.Length;
            if(index == 0) return str;
            else if(index < 0)
            {
                index = length + index;
                if(index < 0) index = 0;
            }
            else
            {
                index--;
                if(index > length) index = length;
            }
            return count >= 0 ? str.Substring(index, count) :
                str.Substring(0, index) + str.Substring(Math.Min(index - count, length));
        }

        public static string GetNumber(string str, int index)
        {
            if(str == null) return null;
            int length = str.Length;
            if(index > 0)
            {
                for(int i = 0, j = -1; i <= length + 1; i++)
                {
                    if(i < length && char.IsDigit(str[i]))
                    {
                        if(j == -1) j = i;
                    }
                    else if(j != -1)
                    {
                        if(--index == 0) return str.Substring(j, i - j);
                        j = -1;
                    }
                }
            }
            else if(index < 0)
            {
                for(int i = length - 1, j = -1; i >= -1; i--)
                {
                    if(i >= 0 && char.IsDigit(str[i]))
                    {
                        if(j == -1) j = i;
                    }
                    else if(j != -1)
                    {
                        if(++index == 0) return str.Substring(i + 1, j - i);
                        j = -1;
                    }
                }
            }
            return string.Empty;
        }

        public static string RemoveNumber(string str, int index)
        {
            if(str == null) return null;
            int length = str.Length;
            if(index > 0)
            {
                for(int i = 0, j = -1; i <= length + 1; i++)
                {
                    if(i < length && char.IsDigit(str[i]))
                    {
                        if(j == -1) j = i;
                    }
                    else if(j != -1)
                    {
                        if(--index == 0) return str.Substring(0, j) + str.Substring(i);
                        j = -1;
                    }
                }
            }
            else if(index < 0)
            {
                for(int i = length - 1, j = -1; i >= -1; i--)
                {
                    if(i >= 0 && char.IsDigit(str[i]))
                    {
                        if(j == -1) j = i;
                    }
                    else if(j != -1)
                    {
                        if(++index == 0) return str.Substring(0, i + 1) + str.Substring(j + 1);
                        j = -1;
                    }
                }
            }
            return string.Empty;
        }
    }
}