/* $Id: options.c 9136 2006-09-18 18:33:58Z grazvydas $ */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "fp_engine.h"

#include "options.h"
#include "demo.h"

vfdmparams options;

typedef struct {
	char 	*name;
	int	value;
} Params;

Params vfdemode[] = {
	{"General",				VFE_MODE_GENERAL},
#ifdef VFDEMO
	{"DigitalPersona U.are.U",		VFE_MODE_DIGITALPERSONA_UAREU},
	{"BiometriKa FX2000",			VFE_MODE_BIOMETRIKA_FX2000},
	{"BiometriKa FX3000",			VFE_MODE_BIOMETRIKA_FX3000},
	{"Keytronic SecureDesktop",		VFE_MODE_KEYTRONIC_SECUREDESKTOP},
	{"Identix TouchView",			VFE_MODE_IDENTIX_TOUCHVIEW},
	{"Identix DFR2090",			VFE_MODE_IDENTIX_DFR2090},
	{"PreciseBiometrics 100CS",		VFE_MODE_PRECISEBIOMETRICS_100CS},
	{"Upek TouchChip",			VFE_MODE_UPEK_TOUCHCHIP},
	{"IdenticatorTechnology DF90",		VFE_MODE_IDENTICATORTECHNOLOGY_DF90},
	{"Authentec AF-S2",			VFE_MODE_AUTHENTEC_AFS2},
	{"Authentec AES4000",			VFE_MODE_AUTHENTEC_AES4000},
	{"Authentec AES2501B",			VFE_MODE_AUTHENTEC_AES2501B},
	{"Atmel FingerChip",			VFE_MODE_ATMEL_FINGERCHIP},
	{"BMF BLP100",				VFE_MODE_BMF_BLP100},
	{"Secugen Hamster",			VFE_MODE_SECUGEN_HAMSTER},
	{"Ethentica",				VFE_MODE_ETHENTICA},
	{"CrossMatch Verifier 300",		VFE_MODE_CROSSMATCH_VERIFIER300},
	{"Nitgen Fingkey Hamster",		VFE_MODE_NITGEN_FINGKEY_HAMSTER},
	{"Testech Bio-i",			VFE_MODE_TESTECH_BIOI},
	{"Digent Izzix",			VFE_MODE_DIGENT_IZZIX},
	{"Startek FM200",			VFE_MODE_STARTEK_FM200},
	{"Fujitsu MBF200",			VFE_MODE_FUJITSU_MBF200},
	{"Futronic FS80",			VFE_MODE_FUTRONIC_FS80},
	{"LighTuning LTT-C500",			VFE_MODE_LIGHTUNING_LTTC500},
	{"Tacoma CMOS",				VFE_MODE_TACOMA_CMOS},
#endif
//	{ "", },
	{ NULL, 0},
};

Params vfdmmode[] = {
	{"General",				VFM_MODE_GENERAL},
#ifdef VFDEMO
	{"DigitalPersona U.are.U",		VFM_MODE_DIGITALPERSONA_UAREU},
	{"BiometriKa FX2000",			VFM_MODE_BIOMETRIKA_FX2000},
	{"BiometriKa FX3000",			VFM_MODE_BIOMETRIKA_FX3000},
	{"Keytronic SecureDesktop",		VFM_MODE_KEYTRONIC_SECUREDESKTOP},
	{"Identix TouchView",			VFM_MODE_IDENTIX_TOUCHVIEW},
	{"Identix DFR2090",			VFM_MODE_IDENTIX_DFR2090},
	{"PreciseBiometrics 100CS",		VFM_MODE_PRECISEBIOMETRICS_100CS},
	{"Upek TouchChip",			VFM_MODE_UPEK_TOUCHCHIP},
	{"IdenticatorTechnology DF90",		VFM_MODE_IDENTICATORTECHNOLOGY_DF90},
	{"Authentec AF-S2",			VFM_MODE_AUTHENTEC_AFS2},
	{"Authentec AES4000",			VFM_MODE_AUTHENTEC_AES4000},
	{"Authentec AES2501B",			VFM_MODE_AUTHENTEC_AES2501B},
	{"Atmel FingerChip",			VFM_MODE_ATMEL_FINGERCHIP},
	{"BMF BLP100",				VFM_MODE_BMF_BLP100},
	{"Secugen Hamster",			VFM_MODE_SECUGEN_HAMSTER},
	{"Ethentica",				VFM_MODE_ETHENTICA},
	{"CrossMatch Verifier 300",		VFM_MODE_CROSSMATCH_VERIFIER300},
	{"Nitgen Fingkey Hamster",		VFM_MODE_NITGEN_FINGKEY_HAMSTER},
	{"Testech Bio-i",			VFM_MODE_TESTECH_BIOI},
	{"Digent Izzix",			VFM_MODE_DIGENT_IZZIX},
	{"Startek FM200",			VFM_MODE_STARTEK_FM200},
	{"Fujitsu MBF200",			VFM_MODE_FUJITSU_MBF200},
	{"Futronic FS80",			VFM_MODE_FUTRONIC_FS80},
	{"LighTuning LTT-C500",			VFM_MODE_LIGHTUNING_LTTC500},
	{"Tacoma CMOS",				VFM_MODE_TACOMA_CMOS},
#endif
	{ NULL, 0},
};


void store_options (void);

GtkWidget *match_at_most_box = NULL;
GtkWidget *match_at_most_entry = NULL;
GtkWidget *quality_treshold_box = NULL;
GtkWidget *quality_treshold_entry = NULL;

static void g_chb_clicked ( GtkWidget *widget, gpointer data)
{
	int use_g = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (data));

	if (use_g)
	{
		gtk_widget_set_sensitive(match_at_most_box, TRUE);
	}
	else
	{
		gtk_widget_set_sensitive(match_at_most_box, FALSE);
		gtk_entry_set_text (GTK_ENTRY(match_at_most_entry), "100");
	}
}

static void g_q_chb_clicked ( GtkWidget *widget, gpointer data)
{
	int use_g = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (data));

	if (use_g)
	{
		gtk_widget_set_sensitive(quality_treshold_box, TRUE);
	}
	else
	{
		gtk_widget_set_sensitive(quality_treshold_box, FALSE);
	}
}


const double ThFARLogRatio = 12;
#define Round(value)    ((int)(value < 0 ? value - 0.5 : value + 0.5))

double VFMatchingThresholdToFAR(int th)
{
	if(th < 0) th = 0;
	return pow(10.0, -th / ThFARLogRatio + 2);
}

int VFFARToMatchingThreshold(double f)
{
	if(f > 100.0) f = 100.0;
	else if(f <= 0.0) f = 1E-100;
	return Round((-log10(f) + 2) * ThFARLogRatio);
}

void options_window ()
{
  GtkWidget *window1;
  GtkWidget *frame;
  GtkWidget *label;
  GtkWidget *entry_dpi;
  GtkWidget *entry_rotation;
  GtkWidget *entry_rotation_gen;
  GtkWidget *entry_fingerid;
  GtkWidget *entry_match;
  GtkWidget *entry_minutia;
  GList *combo_items;
  GtkWidget *combo1;
  GtkWidget *combo2;
  GtkWidget *spinner1;
  GtkWidget *spinner3;
  GtkAdjustment *adj;
  GtkWidget *checkbutton_low;
  GtkWidget *checkbutton_dup;
  GtkWidget *checkbutton_g;
  GtkWidget *checkbutton_all;
  GtkWidget *checkbutton_res;
  GtkWidget *checkbutton_pro;

  int ret, i;
  char buf[80];
  NByte byte;
  NBool boool;

  GtkWidget *vbox1;
  GtkWidget *vbox4;
  GtkWidget *vbox5;
  GtkWidget *vbox6;
  GtkWidget *vbox8;
  GtkWidget *vbox9;
  GtkWidget *hbox1;
  GtkWidget *hbox2;
  GtkWidget *hbox3;
  GtkWidget *hbox4;
  GtkWidget *hbox5;
  GtkWidget *hbox6;
  GtkWidget *hbox7;
  GtkWidget *hbox9;
  GtkWidget *hbox0;

  window1 = gtk_dialog_new_with_buttons ("Options",
				NULL,
				GTK_DIALOG_DESTROY_WITH_PARENT | GTK_DIALOG_NO_SEPARATOR,
				GTK_STOCK_OK,
				GTK_RESPONSE_OK,
				GTK_STOCK_CANCEL,
				GTK_RESPONSE_CANCEL,
				NULL);

  vbox1 = gtk_vbox_new (FALSE, 3);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (GTK_DIALOG (window1)->vbox), vbox1);

/* -- */
  hbox1 = gtk_hbox_new (FALSE, 3);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, FALSE, 3);

#ifdef VFDEMO
  label = gtk_label_new_with_mnemonic ("VeriFinger _Extraction mode\t");
#else
#ifdef FCDEMO
  label = gtk_label_new_with_mnemonic ("FingerCell _Extraction mode\t");
#else
#error select VFDEMO or FCDEMO
#endif
#endif
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox1), label, FALSE, FALSE, 3);

  combo_items = NULL;
  for (i = 0; vfdemode[i].name; i++)
	  combo_items = g_list_append (combo_items, vfdemode[i].name);
  combo1 = gtk_combo_new ();
  gtk_combo_set_popdown_strings (GTK_COMBO(combo1), combo_items);
  gtk_combo_set_value_in_list (GTK_COMBO(combo1), TRUE, FALSE);
  gtk_widget_show (combo1);
  gtk_box_pack_start (GTK_BOX (hbox1), combo1, FALSE, FALSE, 3);
  gtk_label_set_mnemonic_widget (GTK_LABEL (label), GTK_COMBO (combo1)->entry);

/* -- */
  hbox1 = gtk_hbox_new (FALSE, 3);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, FALSE, 3);

#ifdef VFDEMO
  label = gtk_label_new_with_mnemonic ("VeriFinger _Matching mode\t");
#else
#ifdef FCDEMO
  label = gtk_label_new_with_mnemonic ("FingerCell _Matching mode\t");
#else
#error select VFDEMO or FCDEMO
#endif
#endif
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox1), label, FALSE, FALSE, 3);

  combo_items = NULL;
  for (i = 0; vfdmmode[i].name; i++)
	  combo_items = g_list_append (combo_items, vfdmmode[i].name);
  combo2 = gtk_combo_new ();
  gtk_combo_set_popdown_strings (GTK_COMBO(combo2), combo_items);
  gtk_combo_set_value_in_list (GTK_COMBO(combo2), TRUE, FALSE);
  gtk_widget_show (combo2);
  gtk_box_pack_start (GTK_BOX (hbox1), combo2, FALSE, FALSE, 3);
  gtk_label_set_mnemonic_widget (GTK_LABEL (label), GTK_COMBO (combo2)->entry);


#ifdef USE_GENERAL_ALG_MODE
  gtk_widget_set_sensitive(hbox1, 0);
#endif


/* <> */
  hbox2 = gtk_hbox_new (FALSE, 3);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, TRUE, TRUE, 0);

/* -- images from file -- */
  frame = gtk_frame_new (NULL);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (hbox2), frame, TRUE, TRUE, 0);
  gtk_widget_set_size_request (frame, 280, -1);

  hbox4 = gtk_hbox_new (FALSE, 5);
  gtk_widget_show (hbox4);
  gtk_container_add (GTK_CONTAINER (frame), hbox4);

  label = gtk_label_new ("Resolution:");
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox4), label, FALSE, FALSE, 0);

  entry_dpi = gtk_entry_new ();
  gtk_widget_show (entry_dpi);
  gtk_box_pack_start (GTK_BOX (hbox4), entry_dpi, FALSE, FALSE, 0);
  gtk_widget_set_size_request (entry_dpi, 50, -1);

  label = gtk_label_new ("dpi");
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox4), label, FALSE, FALSE, 0);

  label = gtk_label_new ("Images from file");
  gtk_widget_show (label);
  gtk_frame_set_label_widget (GTK_FRAME (frame), label);
/* -- / -- */

/* -- images from scanner -- */
  frame = gtk_frame_new (NULL);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (hbox2), frame, TRUE, TRUE, 0);
  gtk_widget_set_size_request (frame, 280, -1);

  vbox9 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox9);
  gtk_container_add (GTK_CONTAINER (frame), vbox9);

  hbox5 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox5);
  gtk_container_add (GTK_CONTAINER (vbox9), hbox5);

  label = gtk_label_new ("FingerID:");
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox5), label, FALSE, FALSE, 0);

  entry_fingerid = gtk_entry_new ();
  gtk_widget_show (entry_fingerid);
  gtk_box_pack_start (GTK_BOX (hbox5), entry_fingerid, FALSE, FALSE, 5);

  checkbutton_pro = gtk_check_button_new_with_mnemonic ("Prompt for in_fo");
  gtk_widget_show (checkbutton_pro);
  gtk_box_pack_start (GTK_BOX (vbox9), checkbutton_pro, FALSE, FALSE, 0);

  label = gtk_label_new ("Images from scanner");
  gtk_widget_show (label);
  gtk_frame_set_label_widget (GTK_FRAME (frame), label);

/* -- / -- */

/* <> */
  hbox3 = gtk_hbox_new (FALSE, 3);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox3, TRUE, TRUE, 0);

/* -- Enrollment and extraction -- */
  frame = gtk_frame_new (NULL);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (hbox3), frame, TRUE, TRUE, 0);
  gtk_widget_set_size_request (frame, 280, -1);

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox4);
  gtk_container_add (GTK_CONTAINER (frame), vbox4);

  hbox4 = gtk_hbox_new (FALSE, 5);
  gtk_widget_show (hbox4);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox4, FALSE, FALSE, 0);

  label = gtk_label_new_with_mnemonic ("Minimal minutia c_ount");
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox4), label, FALSE, FALSE, 0);

  entry_minutia = gtk_entry_new ();
  gtk_widget_show (entry_minutia);
  gtk_box_pack_start (GTK_BOX (hbox4), entry_minutia, FALSE, FALSE, 0);
  gtk_widget_set_size_request (entry_minutia, 50, -1);

  checkbutton_dup = gtk_check_button_new_with_mnemonic ("Search for du_plicates");
  gtk_widget_show (checkbutton_dup);
  gtk_box_pack_start (GTK_BOX (vbox4), checkbutton_dup, FALSE, FALSE, 0);


  checkbutton_low = gtk_check_button_new_with_mnemonic ("Use low _quality images");
  gtk_widget_show (checkbutton_low);
  gtk_box_pack_start (GTK_BOX (vbox4), checkbutton_low, FALSE, FALSE, 0);

  hbox6 = gtk_hbox_new (FALSE, 0);
  quality_treshold_box = hbox6;
  gtk_widget_show (hbox6);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox6, TRUE, TRUE, 0);

  label = gtk_label_new_with_mnemonic ("Q_uality treshold");
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox6), label, FALSE, FALSE, 0);

  quality_treshold_entry = gtk_entry_new();
  gtk_widget_show (quality_treshold_entry);
  gtk_box_pack_start (GTK_BOX (hbox6), quality_treshold_entry, FALSE, FALSE, 5);
  gtk_widget_set_size_request (quality_treshold_entry, 50, -1);
  gtk_label_set_mnemonic_widget (GTK_LABEL (label), quality_treshold_entry);
  /* make checkbutton_low controll this value */
  g_signal_connect (G_OBJECT (checkbutton_low), "clicked",
			G_CALLBACK (g_q_chb_clicked), (gpointer)checkbutton_low);

  label = gtk_label_new ("%");
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox6), label, FALSE, FALSE, 0);


  label = gtk_label_new ("Enrollment and extraction");
  gtk_widget_show (label);
  gtk_frame_set_label_widget (GTK_FRAME (frame), label);
/* -- / -- */

/* -- Identification -- */
  frame = gtk_frame_new (NULL);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (hbox3), frame, TRUE, TRUE, 0);
  gtk_widget_set_size_request (frame, 280, -1);

  vbox5 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox5);
  gtk_container_add (GTK_CONTAINER (frame), vbox5);

  checkbutton_g = gtk_check_button_new_with_mnemonic ("Use _G");
  gtk_widget_show (checkbutton_g);
  gtk_box_pack_start (GTK_BOX (vbox5), checkbutton_g, FALSE, FALSE, 0);

  hbox6 = gtk_hbox_new (FALSE, 0);
  match_at_most_box = hbox6;
  gtk_widget_show (hbox6);
  gtk_box_pack_start (GTK_BOX (vbox5), hbox6, TRUE, TRUE, 0);

  label = gtk_label_new_with_mnemonic ("Ma_tch at most");
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox6), label, FALSE, FALSE, 0);

  entry_match = gtk_entry_new ();
  match_at_most_entry = entry_match;
  gtk_widget_show (entry_match);
  gtk_box_pack_start (GTK_BOX (hbox6), entry_match, FALSE, FALSE, 5);
  gtk_widget_set_size_request (entry_match, 50, -1);
  gtk_label_set_mnemonic_widget (GTK_LABEL (label), entry_match);
  /* make checkbutton_g controll this value */
  g_signal_connect (G_OBJECT (checkbutton_g), "clicked",
			G_CALLBACK (g_chb_clicked), (gpointer)checkbutton_g);

  label = gtk_label_new ("% of database");
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox6), label, FALSE, FALSE, 0);

  checkbutton_all = gtk_check_button_new_with_mnemonic ("Match _all database");
  gtk_widget_show (checkbutton_all);
  gtk_box_pack_start (GTK_BOX (vbox5), checkbutton_all, FALSE, FALSE, 0);

  checkbutton_res = gtk_check_button_new_with_mnemonic ("Show all _results");
  gtk_widget_show (checkbutton_res);
  gtk_box_pack_start (GTK_BOX (vbox5), checkbutton_res, FALSE, FALSE, 0);

  label = gtk_label_new ("Identification");
  gtk_widget_show (label);
  gtk_frame_set_label_widget (GTK_FRAME (frame), label);
/* -- / -- */

/* <> */
  hbox7 = gtk_hbox_new (FALSE, 3);
  gtk_widget_show (hbox7);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox7, TRUE, TRUE, 0);

/* || */
  vbox6 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox6);
  gtk_box_pack_start (GTK_BOX (hbox7), vbox6, TRUE, TRUE, 0);

/* -- Features generalization -- */
  frame = gtk_frame_new (NULL);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (vbox6), frame, TRUE, TRUE, 0);
  gtk_widget_set_size_request (frame, 280, -1);

  vbox8 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox8);
  gtk_container_add (GTK_CONTAINER (frame), vbox8);

  hbox9 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox9);
  gtk_box_pack_start (GTK_BOX (vbox8), hbox9, TRUE, TRUE, 0);

  label = gtk_label_new ("FAR");
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox9), label, FALSE, FALSE, 3);

  adj = (GtkAdjustment *)gtk_adjustment_new (0.1, 0.0, 100.0, 0.0001, 0.01, 0.0);
  spinner1 = gtk_spin_button_new (adj, 0.5, 5);
  gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spinner1), FALSE);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinner1), TRUE);
  gtk_spin_button_set_update_policy (GTK_SPIN_BUTTON (spinner1), GTK_UPDATE_IF_VALID);
  gtk_box_pack_start (GTK_BOX (hbox9), spinner1, FALSE, FALSE, 3);

  label = gtk_label_new ("%");
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox9), label, FALSE, FALSE, 1);


  hbox0 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox0);
  gtk_box_pack_start (GTK_BOX (vbox8), hbox0, FALSE, FALSE, 0);

  label = gtk_label_new_with_mnemonic ("Maxima_l rotation");
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox0), label, FALSE, FALSE, 0);

  entry_rotation_gen = gtk_entry_new ();
  gtk_widget_show (entry_rotation_gen);
  gtk_widget_set_size_request (entry_rotation_gen, 50, -1);
  gtk_box_pack_start (GTK_BOX (hbox0), entry_rotation_gen, FALSE, FALSE, 5);
  gtk_label_set_mnemonic_widget (GTK_LABEL (label), entry_rotation_gen);

  label = gtk_label_new (""); /* "\260" */
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox0), label, FALSE, FALSE, 0);


  label = gtk_label_new ("Features generalization");
  gtk_widget_show (label);
  gtk_frame_set_label_widget (GTK_FRAME (frame), label);
/* -- / -- */

/* -- Features matching -- */
  frame = gtk_frame_new (NULL);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (hbox7), frame, TRUE, TRUE, 0);
  gtk_widget_set_size_request (frame, 280, -1);

  vbox8 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox8);
  gtk_container_add (GTK_CONTAINER (frame), vbox8);

  hbox9 = gtk_hbox_new (FALSE, 5);
  gtk_widget_show (hbox9);
  gtk_box_pack_start (GTK_BOX (vbox8), hbox9, TRUE, TRUE, 0);

  label = gtk_label_new_with_mnemonic ("_FAR");
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox9), label, FALSE, FALSE, 0);

  adj = (GtkAdjustment *)gtk_adjustment_new (0.1, 0.00, 100.0, 0.0001, 0.01, 0.0);
  spinner3 = gtk_spin_button_new (adj, 0.5, 5);
  gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spinner3), FALSE);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinner3), TRUE);
  gtk_spin_button_set_update_policy (GTK_SPIN_BUTTON (spinner3), GTK_UPDATE_IF_VALID);
  gtk_box_pack_start (GTK_BOX (hbox9), spinner3, FALSE, FALSE, 3);

  label = gtk_label_new ("%");
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox9), label, FALSE, FALSE, 1);

  hbox0 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox0);
  gtk_box_pack_start (GTK_BOX (vbox8), hbox0, FALSE, FALSE, 0);

  label = gtk_label_new_with_mnemonic ("Maxima_l rotation");
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox0), label, FALSE, FALSE, 0);

  entry_rotation = gtk_entry_new ();
  gtk_widget_show (entry_rotation);
  gtk_widget_set_size_request (entry_rotation , 50, -1);
  gtk_box_pack_start (GTK_BOX (hbox0), entry_rotation, FALSE, FALSE, 5);
  gtk_label_set_mnemonic_widget (GTK_LABEL (label), entry_rotation);

  label = gtk_label_new (""); /* "\260" */
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox0), label, FALSE, FALSE, 0);

  label = gtk_label_new ("Features matching");
  gtk_widget_show (label);
  gtk_frame_set_label_widget (GTK_FRAME (frame), label);
/* -- / -- */

/* <end> */
  gtk_widget_show_all (window1);

/* -- query VF options -- */
  /* VFMP_MODE */
  VfmGetParameter(vf_matcher, VFMP_MODE, &ret);
  for (i = 0; vfdmmode[i].name; i++)
  	if (vfdmmode[i].value == ret)
		gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(combo2)->entry), vfdmmode[i].name);

  /* VFMP_MAXIMAL_ROTATION */
  VfmGetParameter(vf_matcher, VFMP_MAXIMAL_ROTATION, &byte);
  ret = Round((double)byte * 180 / 128);
  snprintf (buf, sizeof(buf), "%d", ret);
  gtk_entry_set_text (GTK_ENTRY(entry_rotation), buf);

  /* VFMP_MATCHING_THRESHOLD */
  VfmGetParameter(vf_matcher, VFMP_MATCHING_THRESHOLD, &ret);
  gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinner3), VFMatchingThresholdToFAR(ret));

  /* VFEP_MODE */
  VfeGetParameter(vf_extractor, VFEP_MODE, &ret);
  for (i = 0; vfdemode[i].name; i++)
  	if (vfdemode[i].value == ret)
		gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(combo1)->entry), vfdemode[i].name);

  /* VFEP_GENERALIZATION_MAXIMAL_ROTATION */
  VfeGetParameter(vf_extractor, VFEP_GENERALIZATION_MAXIMAL_ROTATION, &byte);
  ret = Round((double)byte * 180 / 128);
  snprintf (buf, sizeof(buf), "%d", ret);
  gtk_entry_set_text (GTK_ENTRY(entry_rotation_gen), buf);

  /* VFEP_GENERALIZATION_THRESHOLD */
  VfeGetParameter(vf_extractor, VFEP_GENERALIZATION_THRESHOLD, &ret);
  gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinner1), VFMatchingThresholdToFAR(ret));

  /* VFEP_QUALITY_THRESHOLD */
  VfeGetParameter(vf_extractor, VFEP_QUALITY_THRESHOLD, &byte);
  ret = Round((double)byte * 100 / 256);
  snprintf (buf, sizeof(buf), "%d", ret);
  gtk_entry_set_text (GTK_ENTRY(quality_treshold_entry), buf);

  /* VFEP_USE_QUALITY */
  VfeGetParameter(vf_extractor, VFEP_QUALITY_THRESHOLD, &boool);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(checkbutton_low), boool);
  g_q_chb_clicked(checkbutton_low, (gpointer)checkbutton_low);

  /* options */
  snprintf (buf, sizeof(buf), "%d", options.resolution);
  gtk_entry_set_text (GTK_ENTRY(entry_dpi), buf);

  snprintf (buf, sizeof(buf), "%s", options.finger_id);
  gtk_entry_set_text (GTK_ENTRY(entry_fingerid), buf);

  snprintf (buf, sizeof(buf), "%d", options.minutia_count);
  gtk_entry_set_text (GTK_ENTRY(entry_minutia), buf);

  snprintf (buf, sizeof(buf), "%d", options.match_at_most);
  gtk_entry_set_text (GTK_ENTRY(entry_match), buf);

//  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(checkbutton_low), options.low_quality_images); // TODO: remove all
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(checkbutton_dup), options.duplicates);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(checkbutton_g), options.use_g);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(checkbutton_all), options.match_all_db);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(checkbutton_res), options.show_all_results);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(checkbutton_pro), options.prompt);

/* -- RUN DIALOG -- */
  ret = gtk_dialog_run (GTK_DIALOG (window1));
/* -- DIALOG END -- */

  if (GTK_RESPONSE_OK == ret)
  {
  	char *str;
	double rate;
	/* -- set VF options -- */
	/* VFMP_MODE */
	str = (char *)gtk_entry_get_text (GTK_ENTRY(GTK_COMBO(combo2)->entry));
	if (str)
		for (i = 0; vfdmmode[i].name; i++)
			if (strcmp(vfdmmode[i].name, str) == 0)
				VfmSetParameter(vf_matcher, VFMP_MODE, &vfdmmode[i].value);

	/* VFMP_MAXIMAL_ROTATION */
	str = (char *)gtk_entry_get_text (GTK_ENTRY(entry_rotation));
	if ((NULL != str) && (1 == sscanf (str, "%d", &ret)))
	{
		byte = (NByte) Round((double)ret * 128 / 180);
		VfmSetParameter(vf_matcher, VFMP_MAXIMAL_ROTATION, &byte);
	}

	/* VFMP_MATCHING_THRESHOLD */
	rate = gtk_spin_button_get_value (GTK_SPIN_BUTTON (spinner3));
	if (rate > 0.0)
	{
		ret = VFFARToMatchingThreshold (rate);
		VfmSetParameter(vf_matcher, VFMP_MATCHING_THRESHOLD, &ret);
	}

	/* VFEP_MODE */
	str = (char *)gtk_entry_get_text (GTK_ENTRY(GTK_COMBO(combo1)->entry));
	if (str)
		for (i = 0; vfdemode[i].name; i++)
			if (strcmp(vfdemode[i].name, str) == 0)
				VfeSetParameter(vf_extractor, VFEP_MODE, &vfdemode[i].value);

	/* VFEP_GENERALIZATION_MAXIMAL_ROTATION */
	str = (char *)gtk_entry_get_text (GTK_ENTRY(entry_rotation_gen));
	if ((NULL != str) && (1 == sscanf (str, "%d", &ret)))
	{
		byte = (NByte) Round((double)ret * 128 / 180);
		VfeSetParameter(vf_extractor, VFEP_GENERALIZATION_MAXIMAL_ROTATION, &byte);
	}

	/* VFEP_GENERALIZATION_THRESHOLD */
	rate = gtk_spin_button_get_value (GTK_SPIN_BUTTON (spinner1));
	if (rate > 0.0)
	{
		ret = VFFARToMatchingThreshold (rate);
		VfeSetParameter(vf_extractor, VFEP_GENERALIZATION_THRESHOLD, &ret);
	}

	/* VFEP_USE_QUALITY */
	boool = TRUE == gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(checkbutton_low));
	VfeSetParameter(vf_extractor, VFEP_QUALITY_THRESHOLD, &boool);

	/* VFEP_QUALITY_THRESHOLD */
	if (boool)
	{
		str = (char *)gtk_entry_get_text (GTK_ENTRY(quality_treshold_entry));
		if ((NULL != str) && (1 == sscanf (str, "%d", &ret)))
		{
			if (ret > 100) ret = 100;
			if (ret <   0) ret = 0;
			byte = Round((double)ret * 256 / 100);
			VfeSetParameter(vf_extractor, VFEP_QUALITY_THRESHOLD, &byte);
		}
	}

	/* options */
	str = (char *)gtk_entry_get_text (GTK_ENTRY(entry_dpi));
	if ((str != NULL) && (1 == sscanf (str, "%d", &ret)))
		options.resolution = ret;

	str = (char *)gtk_entry_get_text (GTK_ENTRY(entry_fingerid));
	if ((str != NULL) && (str = strdup (str)))
	{
		free (options.finger_id);
		options.finger_id = str;
	}

	str = (char *)gtk_entry_get_text (GTK_ENTRY(entry_minutia));
	if ((str != NULL) && (1 == sscanf (str, "%d", &ret)))
		options.minutia_count = ret;

	str = (char *)gtk_entry_get_text (GTK_ENTRY(entry_match));
	if ((str != NULL) && (1 == sscanf (str, "%d", &ret)))
		options.match_at_most = ret;

//	options.low_quality_images 	= TRUE == gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(checkbutton_low));
	options.duplicates 		= TRUE == gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(checkbutton_dup));
	options.use_g 			= TRUE == gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(checkbutton_g));
	options.match_all_db 		= TRUE == gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(checkbutton_all));
	options.show_all_results 	= TRUE == gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(checkbutton_res));
	options.prompt		 	= TRUE == gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(checkbutton_pro));
  }

  store_options();
  gtk_widget_destroy (window1);
}

void set_default_options (void)
{
	options.low_quality_images = 0;
	options.resolution = 500;
	if (options.finger_id)
		free(options.finger_id);
	options.finger_id = strdup("image from scanner");
	options.minutia_count = 10;
	options.duplicates = 0;
	options.use_g = 1;
	options.match_at_most = 100;
	options.match_all_db = 0;
	options.show_all_results = 0;
	options.prompt = 1;
}

void load_options(void)
{
	int ret;
	char str_input[100], *p;
	FILE *f = fopen(OPTIONS_FILE, "r");

	if (f == NULL)
	{
		goto failed;
	}

	ret = fscanf (f, "%i\n", &options.low_quality_images);
	if (ret != 1)
		goto failed;
	ret = fscanf (f, "%i\n", &options.resolution);
	if (ret != 1)
		goto failed;

	if (options.finger_id)
		free (options.finger_id);
	options.finger_id = fgets (str_input, sizeof(str_input), f);
	if (!options.finger_id)
		goto failed;
	/* get rid of trailing \n */
	p = strrchr(str_input, '\n');
	if (p != NULL)
		*p = '\0';
	options.finger_id = strdup (options.finger_id);

	ret = fscanf (f, "%i\n", &options.minutia_count);
	if (ret != 1)
		goto failed;

	ret = fscanf (f, "%i\n", &options.duplicates);
	if (ret != 1)
		goto failed;
	ret = fscanf (f, "%i\n", &options.use_g);
	if (ret != 1)
		goto failed;
	ret = fscanf (f, "%i\n", &options.match_at_most);
	if (ret != 1)
		goto failed;
	ret = fscanf (f, "%i\n", &options.match_all_db);
	if (ret != 1)
		goto failed;
	ret = fscanf (f, "%i\n", &options.show_all_results);
	if (ret != 1)
		goto failed;
	ret = fscanf (f, "%i\n", &options.prompt);
	if (ret != 1)
		goto failed;

	fclose (f);
	return;

 failed:
	if (f)
		fclose (f);
	fprintf (stderr, "unable to open options file (%s) using default values.\n", OPTIONS_FILE);
	set_default_options ();
}

void store_options (void)
{
	int ret;
	FILE *f = fopen (OPTIONS_FILE, "w");

	if (f == NULL)
	{
		fprintf (stderr, "store_options: unable to open options file (%s)\n", OPTIONS_FILE);
		return;
	}

	ret = fprintf (f, "%i\n", options.low_quality_images);
	if (ret <= 0)
		goto failed;
	ret = fprintf (f, "%i\n", options.resolution);
	if (ret <= 0)
		goto failed;

	ret = fprintf (f, "%s\n", options.finger_id);
	if (ret <= 0)
		goto failed;

	ret = fprintf (f, "%i\n", options.minutia_count);
	if (ret <= 0)
		goto failed;

	ret = fprintf (f, "%i\n", options.duplicates);
	if (ret <= 0)
		goto failed;
	ret = fprintf (f, "%i\n", options.use_g);
	if (ret <= 0)
		goto failed;
	ret = fprintf (f, "%i\n", options.match_at_most);
	if (ret <= 0)
		goto failed;
	ret = fprintf (f, "%i\n", options.match_all_db);
	if (ret <= 0)
		goto failed;
	ret = fprintf (f, "%i\n", options.show_all_results);
	if (ret <= 0)
		goto failed;
	ret = fprintf (f, "%i\n", options.prompt);
	if (ret <= 0)
		goto failed;


	fclose (f);
	return;

 failed:
	fprintf (stderr, "store_options: error while writing file\n");
	fclose (f);
}
